#ifndef FM94ELEM_H
#pragma once
//#include <afx.h>
#include <vector>
#define FM94ELEM_H
#define NoOfInstruments 55
#define Elem22068 32
#define Elem22178 13
#define Elem2002 6
#define Elem1036 35
#define Elem2030 7
#define Elem33003 4
#define Elem48303 3
#define Elem48604 5
//typedef struct {int size; char* Mess;} RetMess;


/*struct CodeTable1
{
	short Code;
	CString Definition;
};
*/
struct CodeTable
{
	short Code;
	char * Definition;
};

struct AgencyTable
{
	int Code;
	char * Definition;
};


//using namespace std ;
typedef std::vector <CodeTable> CodeTableVect;
typedef std::vector <AgencyTable> AgencyTableVect;

/*struct RecorderType
{
	short CodeFigure;
	char *Recorder;
};
*/
struct Profiler

	{
		short InstrNo;
		double Acoeff;
		double Bcoeff;
		int MaxDepth;
		char *Instrument;

	};

struct SingleCoeff

	{
		short InstrNo;
		double Acoeff;
		double Bcoeff;
	};

union FM94Value
{
	// Use union to overlay space
	char StrVal[60];
	unsigned long Integ;
};

		
class FM94Elem
	{
//	private:
	protected:
		int classid;
		int	version;
		int offset;
		int minimum;
		int bits;
		int maximum;
		int scale;
		char Desc[80];
		char units[15];
	protected:
		FM94Value Value;
		FM94Value BufrVal;
		bool Valid;

	public:
		FM94Elem();
		~FM94Elem();
		void Init(int,  int, int, int, int, int, int, char *, char *);
//		void clear();
		int GetClassId();
		int GetVersion();
		int GetOffset();
		int GetMinimum();
		int GetMaxBits();
		int GetMaximum();
		int GetScale();
		char *GetDesc();
		char *GetUnits();
		bool IsValid();
		void SetValue(char *valuein);
		void SetValue(int valuein);
		void SetValue(unsigned long valuein);
		char *GetBufrVal();
		FM94Value GetValue();
	};

class CodeTableElem : public FM94Elem
{
protected : CodeTableVect Table;
public : CodeTableElem();
	CodeTable GetTableElem(int);
	int GetNoElems();
	CodeTable GetTableElemAt(int);
	bool ValidValue(int);

};

// Special calss for Agency table due to size of the Agency Code (7 digits)
class AgencyTableElem : public FM94Elem
{
protected : AgencyTableVect Table;
public : AgencyTableElem();
	AgencyTable GetTableElem(int);
	int GetNoElems();
	AgencyTable GetTableElemAt(int);
	bool ValidValue(int);

};

// Call Sign
class FXY1011 : public FM94Elem
{

public : FXY1011();
};
// Ship's Direction
class FXY1012 : public FM94Elem
{

public : FXY1012();
};

// Ship's Speed
class FXY1013 : public FM94Elem
{

public : FXY1013();
};

// Ship's Speed
class FXY1013A : public FM94Elem
{

public : FXY1013A();
};

//FXY1036    Agency in charge of operating the observing platform

class FXY1036 : public AgencyTableElem
{
protected : 
	AgencyTable Agency[Elem1036];

public : FXY1036();
//		 int SetValue(int);
//		 int GetNoInst();
//		 Profiler GetInstAt(int);
//		 Profiler GetInstrument(int);
};

// Ship Line Number According to SOOP
class FXY1080 : public FM94Elem
{

public : FXY1080();
};

// Ship Name
class FXY1200 : public FM94Elem
{
public : FXY1200();
};

// Ship's Lloyds (IMO) number
class FXY1201 : public FM94Elem
{
public : FXY1201();
};
// FXY2002 Type of Instrument for Wind Measurement
class FXY2002 : public CodeTableElem
{
protected:
//	CodeTable Table[Elem2002];
public : FXY2002();
		 int SetValue(int);

};


// FXY2030 Method of Current Measurement
class FXY2030 : public CodeTableElem
{
protected:
//	CodeTable Table[Elem2030];
public : FXY2030();
};

// FXY2038 METH OF SEA TEMPERATURE MEASURE
class FXY2038 : public FM94Elem
{
public : FXY2038();
};

// FXY2039 METH OF WET BULB TEMPERATURE MEASURE
class FXY2039 : public FM94Elem
{
public : FXY2039();
};

// FXY2171 Instrument serial number for water temperature profile measurement
class FXY2171 : public FM94Elem
{
public : FXY2171();
};

// FXY4001 Year
class FXY4001 : public FM94Elem
{
public : FXY4001();
};

// FXY4002 Month of Year
class FXY4002 : public FM94Elem
{
public : FXY4002();
};

// FXY4003 Day of Month
class FXY4003 : public FM94Elem
{
public : FXY4003();
};

// FXY4004 Hour of Day
class FXY4004 : public FM94Elem
{
public : FXY4004();
};

// FXY4005 Minute of Hour
class FXY4005 : public FM94Elem
{
public : FXY4005();
};

// FXY4006 Second of Minute
class FXY4006 : public FM94Elem
{
public : FXY4006();
};

// FXY4025 Time period or displacement minutes
class FXY4025 : public FM94Elem
{
public : FXY4025();
};

// FXY4025 Time period or displacement minutes
class FXY4025A : public FM94Elem
{
public : FXY4025A();
};

// FXY4209 MINUTE OF MONTH
class FXY4209 : public FM94Elem
{
public : FXY4209();
};
//Latitude High Accuracy
class FXY5001 : public FM94Elem
{
public : FXY5001();
};

//Latitude Coarse Accuracy
class FXY5002 : public FM94Elem
{
public : FXY5002();
};

//Latitude Increment High Accuracy
class FXY5011 : public FM94Elem
{
public : FXY5011();
};

//Latitude Increment Coarse Accuracy
class FXY5012 : public FM94Elem
{
public : FXY5012();
};

//Latitude Increment Coarse Accuracy SEAS IV
class FXY5012S4 : public FM94Elem
{
public : FXY5012S4();
};

//Latitude Increment Coarse Accuracy SEAS IV AMVER SP
class FXY5012S4A : public FM94Elem
{
public : FXY5012S4A();
};

// FXY5036 Ship Transect Number
class FXY5036 : public FM94Elem
{
public : FXY5036();
};


//Longitude High Accuracy
class FXY6001 : public FM94Elem
{
public : FXY6001();
};

//Longitude Coarse Accuracy
class FXY6002 : public FM94Elem
{
public : FXY6002();
};

//Longitude Increment High Accuracy
class FXY6011 : public FM94Elem
{
public : FXY6011();
};

//Longitude Increment Coarse Accuracy
class FXY6012 : public FM94Elem
{
public : FXY6012();
};

//Longitude Increment Coarse Accuracy SEAS IV
class FXY6012S4 : public FM94Elem
{
public : FXY6012S4();
};

//Longitude Increment Coarse Accuracy SEAS IV AMVER SP
class FXY6012S4A : public FM94Elem
{
public : FXY6012S4A();
};

// Depth Below Sea/Water Surface
class FXY7062 : public FM94Elem
{
public : FXY7062();
};

// Depth Below Sea/Water Surface
class FXY7062S : public FM94Elem
{
public : FXY7062S();
};

//FXY10051 PRESSURE REDUCED TO MSL
class FXY10051 : public FM94Elem
{
public : FXY10051();
};

//FXY10061 3 HOUR PRESSURE CHANGE 
class FXY10061 : public FM94Elem
{
public : FXY10061();
};

//FXY10063 CHARACTERISTIC OF PRESSURE TENDENCY
class FXY10063 : public FM94Elem
{
public : FXY10063();
};

//FXY11001 Wind Direction
class FXY11001 : public FM94Elem
{
public : FXY11001();
};
//FXY11001S4 Wind Direction
class FXY11001A : public FM94Elem
{
public : FXY11001A();
};

//FXY11002 Wind Speed
class FXY11002 : public FM94Elem
{
public : FXY11002();
};

//FXY11002 Wind Speed Knots
class FXY11223 : public FM94Elem
{
public : FXY11223();
};

//FXY12004 Dry Bulb Temperature Degrees K = 273.15+ Degrees C
class FXY12004 : public FM94Elem
{
	public : FXY12004();
};

//FXY12004A Dry Bulb Temperature Degrees K = 273.15+ Degrees C MET
class FXY12004A : public FM94Elem
{
	public : FXY12004A();
};

//FXY12005A WetBulb Temperature Degrees K = 273.15+ Degrees C
class FXY12005A : public FM94Elem
{
	public : FXY12005A();
};

//FXY20003  PRESENT WEATHER
class FXY20003 : public FM94Elem
{
	public : FXY20003();

};

//FXY20004  PAST WEATHER (1)
class FXY20004 : public FM94Elem
{
	public : FXY20004();

};

//FXY20005 PAST WEATHER (2)
class FXY20005 : public FM94Elem
{
	public : FXY20005();

};

//FXY20011 CLOUD AMOUNT
class FXY20011 : public FM94Elem
{
	public : FXY20011();

};

//FXY20012 CLOUD TYPE
class FXY20012 : public FM94Elem
{
	public : FXY20012();

};

//FXY20031 THICKNESS OF ICE ACCRETION
class FXY20031 : public FM94Elem
{
	public : FXY20031();
};

//FXY20032 RATE OF ICE ACCRETION
class FXY20032 : public FM94Elem
{
	public : FXY20032();
};

//FXY20033 CAUSE OF ICE ACCRETION
class FXY20033 : public FM94Elem
{
	public : FXY20033();
};

//FXY20034 SEA ICE CONCENTRATION
class FXY20034 : public FM94Elem
{
	public : FXY20034();
};

//FXY20035 AMOUNT AND TYPE OF ICE
class FXY20035 : public FM94Elem
{
	public : FXY20035();
};

//FXY20036 ICE SITUATION
class FXY20036 : public FM94Elem
{
	public : FXY20036();
};

//FXY20037 ICE DEVELOPMENT
class FXY20037 : public FM94Elem
{
	public : FXY20037();
};

//FXY20193 LOWEST CLOUDS  
class FXY20193 : public FM94Elem
{
	public : FXY20193();
};

//FXY20194 HORIZONTAL VISIBILITY
class FXY20194 : public FM94Elem
{
	public : FXY20194();
};

//FXY20195 CLOUD COVERAGE TENTHS 
class FXY20195 : public FM94Elem
{
	public : FXY20195();
};


//FXY20197 BEARING OF SEAS ICE   
class FXY20197 : public FM94Elem
{
	public : FXY20197();
};

//FXY20201    MEASURED WIND INDICATOR
class FXY20201 : public FM94Elem
{
	public : FXY20201();

};

//FXY22003 Direction of Swell Waves
class FXY22003 : public FM94Elem
{
	public : FXY22003();
};

//FXY22004 Direction of Current
class FXY22004 : public FM94Elem
{
	public : FXY22004();
};

//FXY22012 PERIOD OF WAVES
class FXY22012 : public FM94Elem
{
	public : FXY22012();
};

//FXY22013 Period of Swell Waves
class FXY22013 : public FM94Elem
{
	public : FXY22013();
};

//FXY22031 Speed of Current
class FXY22031 : public FM94Elem
{
	public : FXY22031();
};

//FXY22042 Sea/Water Temperature Degrees K = 273.15+ Degrees C
class FXY22042 : public FM94Elem
{
	public : FXY22042();
};

//FXY22042S Sea/Water Temperature Degrees Degrees C
class FXY22042S : public FM94Elem
{
	public : FXY22042S();
};

//FXY22042T Sea/Water Temperature Degrees Degrees C // for SEABIRD TSG
class FXY22042T : public FM94Elem
{
	public : FXY22042T();
};

//FXY22042S4 Sea/Water Temperature Degrees Degrees F // for SEAS IV Weather
class FXY22042S4 : public FM94Elem
{
	public : FXY22042S4();
};

//FXY22044 Sound Velocity 
class FXY22044 : public FM94Elem
{
	public : FXY22044();
};

//FXY22062 Salinity part per thousand
class FXY22062 : public FM94Elem
{
	public : FXY22062();
};

//FXY22063 Total Water Depth
class FXY22063 : public FM94Elem
{
	public : FXY22063();
};

//FXY22066 Conductivity Siemens Per Meter
class FXY22066 : public FM94Elem
{
	public : FXY22066();
};

//FXY22067    Instrument type for water temperature profile measurement
class FXY22067 : public FM94Elem
{
protected : 
	Profiler Instr[NoOfInstruments];

public : FXY22067();
		 SingleCoeff GetCoeff();
		 int SetValue(int);
		 int GetNoInst();
		 Profiler GetInstAt(int);
		 Profiler GetInstrument(int);
};

//FXY22068    PROFILE MEASUREMENT RECORDER TYPE
class FXY22068 : public CodeTableElem
{
protected :
//	CodeTable Recorders[NoOfRecorders];
public : FXY22068();

};

//FXY22178    XBT/XCTD LAUNCHER TYPE
class FXY22178 : public CodeTableElem
{
protected :
//	CodeTable Recorders[NoOfRecorders];
public : FXY22178();

};

//FXY22195 HEIGHT OF WIND WAVES
class FXY22195 : public FM94Elem
{
	public : FXY22195();
};

//FXY22196 HEIGHT OF SWELL WAVES
class FXY22196 : public FM94Elem
{
	public : FXY22196();
};

// Number of times replicated fields are duplicated
class FXY31001 : public FM94Elem
{
public : FXY31001();
};

// Number of times replicated fields are duplicated
class FXY31001A : public FM94Elem
{
public : FXY31001A();
};

// Number of times replicated fields are duplicated
class FXY31001B : public FM94Elem
{
public : FXY31001B();
};

// Number of times replicated fields are duplicated
class FXY31200 : public FM94Elem
{
public : FXY31200();
};


// FXY33003 Data Quality Information

class FXY33003 : public CodeTableElem
{
protected:
//	CodeTable Table[Elem33003];
public : FXY33003();
};


//FXY48001 

// Generic identfication flags used to determine whether or not an attribute is included in a message
// I.E. is the high resolution temperature transmitted in the TSG message.
// Use determined by the containing object
class FXY48001 : public FM94Elem
{
public : FXY48001();
};

// Ship's Direction
class FXY48004 : public FM94Elem
{

public : FXY48004();
};

// Ship's Speed
class FXY48031 : public FM94Elem
{

public : FXY48031();
};

// AMVER DESTINATION PORT NUMBER 
class FXY48194 : public FM94Elem
{
public : FXY48194();
};

// AMVER Navigation
class FXY48197 : public FM94Elem
{
public : FXY48197();
};

// AMVER Navigation
class FXY48197A : public FM94Elem
{
public : FXY48197A();
};


// AMVER Medical Resources
class FXY48198 : public FM94Elem
{
public : FXY48198();
};

// AMVER DISTRIBUTION 
class FXY48199 : public FM94Elem
{
public : FXY48199();
};

// FXY48200 RADIO STATION
class FXY48200 : public FM94Elem
{
public : FXY48200();
};

// SEAS Software Version Number
class FXY48201 : public FM94Elem
{
public : FXY48201();
};

// FXY48202 INMARSAT-C TRANSCEIVER MANUFACTURER CODE
class FXY48202 : public FM94Elem
{
public : FXY48202();
};

// FXY48203 GPS MANUFACTURER CODE
class FXY48203 : public FM94Elem
{
public : FXY48203();
};

// FXY48204 TRANSMITTER SOFTWARE VERSION
class FXY48204 : public FM94Elem
{
public : FXY48204();
};

// FXY48207 INMARSAT OCEAN AREAS
class FXY48207 : public FM94Elem
{
public : FXY48207();
};

// FXY48208 INMARSAT-C MOBIL ID NUMBER FOR EMERGENCY
class FXY48208 : public FM94Elem
{
public : FXY48208();
};

// FXY48211 Inmarsat sub category Pre SEAS2K
class FXY48211 : public FM94Elem
{
public : FXY48211();
};

// FXY48212 INMARSAT-A NUMBER  
class FXY48212 : public FM94Elem
{
public : FXY48212();
};

// FXY48213 ADMIN REPORT TYPE 
class FXY48213 : public FM94Elem
{
public : FXY48213();
};


// FXY48214 MAXIMUM SHIP SPEED KNOTS
class FXY48214 : public FM94Elem
{
public : FXY48214();
};

// Inmarsat sub category SEAS2K and after
class FXY48216 : public FM94Elem
{
public : FXY48216();
};

//FXY48300  Probe Serial Number  
class FXY48300 : public FM94Elem
{
public : FXY48300();
};

//FXY48300A  Probe Serial Number  
class FXY48300A : public FM94Elem
{
public : FXY48300A();
};


//FXY48301  Cruise Name
class FXY48301 : public FM94Elem
{
public : FXY48301();
};

//FXY48302  Unique Tag
class FXY48302 : public FM94Elem
{
public : FXY48302();
};


// FXY48303  Type Data In Message
class FXY48303 : public CodeTableElem
{
protected:
//	CodeTable Table[Elem48303];
public : FXY48303();
};

//	Message Sequence Number
class FXY48304 : public FM94Elem
{
public : FXY48304();
};

//FXY48305 Launch Height
class FXY48305 : public FM94Elem
{
public : FXY48305();
};
// Code Table 2604 Salinity, Sea Temp, Current speed/dir averaging period
class FXY48604 : public CodeTableElem
{
protected:
	CodeTable A[Elem48604];

public :FXY48604();
		int SetValue(int);
};


// Delayed replication factor
class FXY100000 : public FM94Elem
{
public : FXY100000();
};

// Delayed replication factor
class FXY104000 : public FM94Elem
{
public : FXY104000();
};

// FXY205030 COMMENTS
class FXY205030 : public FM94Elem
{
public : FXY205030();
};

// FXY205030 COMMENTS
class FXY205030A : public FM94Elem
{
public : FXY205030A();
};
#endif
