//#include "stdafx.h"
#include <jjvv_1.h>
#include <math.h>
#include <float.h>
#include <time.h>
#include <iostream>

//PIC 11/05/2014

//#define SCRIPPS

//#include <FM94Elem.h>
//	CStdioFile Myfile, MyfileO;

using namespace std;

JJVV::JJVV()
{
	BinaryMess = NULL;
//	EnoughToXmit = false;
	TailsRem = false;
	OneMeterComputed = false;
	TailDepth = -1;
	InflectComp = false;
	Smoothed=false;
	CRC = -1;
//	ASCIIDecode = false;

	// CRC Constants
	order = 32;
	polynom = 0x4c11db7;
	direct = 1;
	crcinit = 0xffffffff;
	crcxor = 0xffffffff;
	refin = 1;
	refout = 1;


	SetMessType(1);
	SEAS_Elem.push_back(&ShipName);
	SEAS_Elem.push_back(&Lloyds);
//	FXY48301 CruiseName;
	SEAS_Elem.push_back(&UniqueTag);
	SEAS_Elem.push_back(&SEASVersion);
	SEAS_Elem.push_back(&ProbeSerial);
	SEAS_Elem.push_back(&ThisDataIs);
	SEAS_Elem.push_back(&DataQual);
	SEAS_Elem.push_back(&InstType);
	SEAS_Elem.push_back(&RecorderType);
	SEAS_Elem.push_back(&TypeWindInst);
	SEAS_Elem.push_back(&WindDir);
	SEAS_Elem.push_back(&WindSpeed);
	SEAS_Elem.push_back(&DryBulbTemp);
	SEAS_Elem.push_back(&CurrMeasMeth);
	SEAS_Elem.push_back(&CurrentDir);
	SEAS_Elem.push_back(&CurrentSpeed);
	SEAS_Elem.push_back(&TotalWaterDepth);
	SEAS_Elem.push_back(&NoRepFields);
	SEAS_Elem.push_back(&TimesReplicated);
//	SEAS_Elem.push_back(&SeaTemp);
//	SEAS_Elem.push_back(&SeaDepth);
	ComputeMessSize();

};



JJVV::~JJVV()
{
	if(BinaryMess != NULL)
	{delete [] BinaryMess;}
};


void JJVV::RemoveNumOfRTPoints()//JB
{
	MySeaTemp.clear();
	RawSeaTemp.clear();
}

int  JJVV::GetProbeSerial()//Added JB
{	
	return 	ProbeSerial.GetValue().Integ;

}
void JJVV::SetShipName(char *Ship)
{
	ShipName.SetValue(Ship);
};

/*JJVV::SetCruiseName(char *Name)
{
	CruiseName.SetValue(Name);
};
*/

void JJVV::SetProbeSerial(int SN)
{
	ProbeSerial.SetValue(SN);
};


void JJVV::SetSEASVersion(int Ver)
{
	SEASVersion.SetValue(Ver);
};

void JJVV::SetDataQual(int DQ)
{
	DataQual.SetValue(DQ);
};

void JJVV::SetInstType(int IT)
{
	InstType.SetValue(IT);
};


void JJVV::SetRecorderType(int RT)
{
	RecorderType.SetValue(RT);
};

void JJVV::SetDryBulbTemp(float DBT)
{
	int s = DryBulbTemp.GetScale();
	int off = DryBulbTemp.GetOffset();
	float y = (float)((int)((fabs((double) DBT) + 0.05) *10.0))/10.0;
#ifdef _WIN32
	float y1 = _copysign(1, DBT);
	float y2 = ((fabs((double) DBT) + 0.05) * _copysign(1, DBT));
	int x = (int)((273.15 + ((float)((int)((fabs((double) DBT) + 0.05)*10.0)/10.0) * _copysign(1, DBT))) * pow(10,(double)s)) - off;
#endif
#ifndef _WIN32
	float y1 = copysign(1, DBT);
	float y2 = ((fabs((double) DBT) + 0.05) * copysign(1, DBT));
	int x = (int)((273.15 + ((float)((int)((fabs((double) DBT) + 0.05)*10.0)/10.0) * copysign(1, DBT))) * pow(10,(double)s)) - off;
#endif
	DryBulbTemp.SetValue(x);
	
};

void JJVV::SetTotalWaterDepth(int TD)
{
	TotalWaterDepth.SetValue(TD);
};


void JJVV::SetCurrentSpeed(float CS) //Speed in Knots
{
	float k = (CS *(1852.0/(3600.0*pow(10,(double) - CurrentSpeed.GetScale()))));//+.5);
	int x = (int) (k+.5);
//	int x = (int) (CS *(1852.0/(3600.0*pow(10,(double) - CurrentSpeed.GetScale())))+.5);
	CurrentSpeed.SetValue(x);
}

void JJVV::SetCurrentDir(int CD)
{
	CurrentDir.SetValue(CD);
}

void JJVV::SetWindSpeed(float WS)
{
	float k = (WS *(1852.0/(3600.0*pow(10,(double) -WindSpeed.GetScale()))));//+.5);
	int x = (int) (k+.5);
//	int x = (int) (WS *(1852.0/(3600.0*pow(10,(double) -WindSpeed.GetScale()))))//+.5);
	WindSpeed.SetValue(x);
}

void JJVV::SetWindDir(int WD)
{
	WindDir.SetValue(WD);
}


/*JJVV::SetShipSpeed(float SS)
{
	if(GetMessType()==1)
	{
		SetMessType(2);
		SEAS_Elem.InsertAt(16,&ShipSpeed);
		SEAS_Elem.InsertAt(16,&ShipDir);
		ComputeMessSize();
	}

	float k = (SS *(1852.0/(3600.0*pow(10,(double) -ShipSpeed.GetScale()))));//+.5);
	int x = (int) (k+.5);
//	int x = (int) (WS *(1852.0/(3600.0*pow(10,(double) -WindSpeed.GetScale()))))//+.5);
	ShipSpeed.SetValue(x);
}

JJVV::SetShipDir(int SD)
{
	if(GetMessType()==1)
	{
		SetMessType(2);
		SEAS_Elem.InsertAt(16,&ShipSpeed);
		SEAS_Elem.InsertAt(16,&ShipDir);
		ComputeMessSize();
	}
	ShipDir.SetValue(SD);
}
*/
void JJVV::SetCurrMeasMeth(int CMM)
{
	CurrMeasMeth.SetValue(CMM);
}

void JJVV::SetLloyds(int LN)
{
	Lloyds.SetValue(LN);
}

void JJVV::SetUniqueTag(time_t X, time_t Y)
{
	
		unsigned long z = (X-946684800)+(Y-946684800);
		UniqueTag.SetValue(z);
}

void JJVV::SetUniqueTag(unsigned long z)
{
	
//		long z = (X-946684800)+(Y-946684800);
		UniqueTag.SetValue(z);
}


void JJVV::SetTypeWindInst(int W)
{
	TypeWindInst.SetValue(W);
}



std::string JJVV::GetShipName()
{
	string x = ShipName.GetValue().StrVal;
	if(x.at(0) == (char)255)
	{
		x = "";
	}
	return x;
}

void JJVV::SetDataType(int dt)
{
	ThisDataIs.SetValue(dt);
}


//Add a temperature to the Vector

void JJVV::AddNewTemp(float k)
{
	FXY22042S y;
	int x = (int) (k * pow(10,(double) y.GetScale())+.5)-y.GetOffset();
	y.SetValue(x);
	MySeaTemp.push_back(y);
	RawSeaTemp.push_back(k);
}


int JJVV::GetInstType()
{
	return InstType.GetValue().Integ;
};


Profiler JJVV::GetInstInfo(int Inst)
{
	Profiler a = InstType.GetInstrument(Inst);
	return a;
}

int JJVV::GetRecorderType()
{
	return RecorderType.GetValue().Integ;
};


int JJVV::GetSEASVersion()
{
	return SEASVersion.GetValue().Integ;
};

int JJVV::GetDataQual()
{
	return DataQual.GetValue().Integ;
};

CodeTable JJVV::GetDataQualInfo(int dqi)
{
	return DataQual.GetTableElem(dqi);
};

CodeTable JJVV::GetRecorderInfo(int rec)
{
	return RecorderType.GetTableElem(rec);
};

int JJVV::GetDataType()
{
	return ThisDataIs.GetValue().Integ;
};

CodeTable JJVV::GetDataTypeInfo(int dqi)
{
	return ThisDataIs.GetTableElem(dqi);
};

int JJVV::GetTypeWindInst()
{
	return TypeWindInst.GetValue().Integ;
}

CodeTable JJVV::GetTypeWindInstInfo(int wi)
{
	return TypeWindInst.GetTableElem(wi);
}


float JJVV::GetWindSpeed()
{
	if(WindSpeed.GetValue().Integ == -1)
	{return -1;}
	float x = (WindSpeed.GetValue().Integ)/(1852.0/(3600.0*pow(10,(double) -WindSpeed.GetScale())));
//	float y = ((x+.5)*pow(10.0,(double) WindSpeed.GetScale()));
	x= (float)((int)((x)*pow(10.0,(double) WindSpeed.GetScale())+.5));
	x= x/pow(10.0,(double) WindSpeed.GetScale());
	return x; 

}

int JJVV::GetWindDir()
{
	return WindDir.GetValue().Integ;
}

int JJVV::GetCurrMeasMeth()
{
	return CurrMeasMeth.GetValue().Integ;
}

CodeTable JJVV::GetCurrMeasMethInfo(int cm)
{
	return CurrMeasMeth.GetTableElem(cm);
}

int JJVV::GetLloyds( )
{
	return Lloyds.GetValue().Integ;
}

float JJVV::GetDryBulbTemp()
{
	int y = DryBulbTemp.GetValue().Integ;
	if(y==-1)
	{
		return -9999.0;
	}
	int s = DryBulbTemp.GetScale();
	int off = DryBulbTemp.GetOffset();
	float x = (float) ((float)DryBulbTemp.GetValue().Integ + off) * pow(10.0,(double) -s) - 273.1 ;
	return x;
};

int JJVV::GetTotalWaterDepth()
{
	return TotalWaterDepth.GetValue().Integ;
};


float JJVV::GetCurrentSpeed() //Speed in Knots
{
	if(CurrentSpeed.GetValue().Integ==-1)
	{
		return -1;
	}
	float  x = (CurrentSpeed.GetValue().Integ)/(1852.0/(3600.0*pow(10,(double) -CurrentSpeed.GetScale())));
	x= (float)((int)(x*pow(10.0,(double) CurrentSpeed.GetScale())+.5));
	x= x/pow(10.0,(double) CurrentSpeed.GetScale());

	return x;
 }

int JJVV::GetCurrentDir()
{
	return CurrentDir.GetValue().Integ;
}
//
/*float JJVV::GetShipSpeed() //Speed in Knots
{
	if(ShipSpeed.GetValue().Integ==-1)
	{
		return -1;
	}
	float  x = (ShipSpeed.GetValue().Integ)/(1852.0/(3600.0*pow(10,(double) -ShipSpeed.GetScale())));
	x= (float)((int)(x*pow(10.0,(double) ShipSpeed.GetScale())+.5));
	x= x/pow(10.0,(double) ShipSpeed.GetScale());

	return x;
 }

int JJVV::GetShipDir()
{
	return ShipDir.GetValue().Integ;
}

float JJVV::GetRawTempAt(int k)
{
	if(RawSeaTemp.size()>=k)
	{
		return RawSeaTemp.at(k);
	}
	else
	{return -99.0;}
}
*/
//

float JJVV::GetRawTempAt(int k)
{
	if(RawSeaTemp.size()>=k)
	{
		return RawSeaTemp.at(k);
	}
	else
	{return -99.0;}
}

//
float JJVV::GetTempAtPos(int k)
{
	float x = (float) -9999;
	if(k < MySeaTemp.size())
	{
		x=MySeaTemp.at(k).GetValue().Integ;
		x = (x+MySeaTemp.at(k).GetOffset())/pow(10.0, MySeaTemp.at(k).GetScale());
	}
	return x;
}

float JJVV::GetTempAtDepth(int Depth)
{
	float RetTemp = (float) -9999;
	if(Depth >=1)
	{
		SingleCoeff inst = InstType.GetCoeff();
		if(inst.InstrNo!= -1)
		{
			if((inst.Acoeff!= -1)&&(inst.Bcoeff!= -1))
			{	
				double a = .001*inst.Bcoeff;
				double b = inst.Acoeff;
				double c = -Depth;
				double x1 = sqrt(b*b - 4.0*a*c );
				double tim1 = (-b + x1)/(2.0*a) *10.0;
				int pos;
				double pos1;
				double remain = modf( tim1, &pos1);
				pos = (int) pos1;
				int mysize = MySeaTemp.size();
				if(pos <= MySeaTemp.size()-1)
				{
					float tb = MySeaTemp.at(pos-1).GetValue().Integ + MySeaTemp.at(pos-1).GetOffset();
					float tt = MySeaTemp.at(pos).GetValue().Integ+ MySeaTemp.at(pos-1).GetOffset();
					float dif = tt - tb;
					RetTemp = (int)(tb + dif * remain + 0.5)/pow(10.0, MySeaTemp.at(pos).GetScale());
					
				}
	//		tim2 = (-b - x1)/(2.0*a);
			}
		}
	}
	return (float) RetTemp;

}

float JJVV::GetSmoothTempAtDepth(int Depth)
{
	float RetTemp = (float) -9999;
	if(Depth >=1)
	{
		SingleCoeff inst = InstType.GetCoeff();
		if(inst.InstrNo!= -1)
		{
			if((inst.Acoeff!= -1)&&(inst.Bcoeff!= -1))
			{	
				double a = .001*inst.Bcoeff;
				double b = inst.Acoeff;
				double c = -Depth;
				double x1 = sqrt(b*b - 4.0*a*c );
				double tim1 = (-b + x1)/(2.0*a) *10.0;
				int pos;
				double pos1;
				double remain = modf( tim1, &pos1);
				pos = (int) pos1;
				int mysize = SmoothPts.size();
				if(pos <= SmoothPts.size()-1)
//				if(pos <= SmoothPts.size())
				{
					float tb = SmoothPts.at(pos-1);
					float tt = SmoothPts.at(pos);
					float dif = tt - tb;
					RetTemp = (tb + dif * remain); //pow(10.0, MySeaTemp.at(pos).GetScale());
					
				}
	//		tim2 = (-b - x1)/(2.0*a);
			}
		}
	}
	return (float) RetTemp;

}


float JJVV::GetDepthAtPos(int pos)
{
	float RetDepth = -9999;
	float x = (pos+1)/10.0;
	SingleCoeff inst = InstType.GetCoeff();
	if(inst.InstrNo!= -1)
	{
		if((inst.Acoeff!= -1)&&(inst.Bcoeff!= -1))
		{	
			double a = .001*inst.Bcoeff;
			double b = inst.Acoeff;
			double depth = a*x*x + b*x;
			RetDepth = (float) depth;
		}
	}
	return RetDepth;
}

int JJVV::ComputeLastDepth()
{
	int RetDepth = -1;
	float x = MySeaTemp.size()/10.0;
	SingleCoeff inst = InstType.GetCoeff();
	if(inst.InstrNo!= -1)
	{
		if((inst.Acoeff!= -1)&&(inst.Bcoeff!= -1))
		{	
			double a = .001*inst.Bcoeff;
			double b = inst.Acoeff;
			double depth = a*x*x + b*x +.5;
			RetDepth = (int) depth;
		}
	}
	return RetDepth;
}

int JJVV::ComputeLastSmoothDepth()
{
	int RetDepth = -1;
//	float x = MySeaTemp.size()/10.0;
	float x = SmoothPts.size()/10.0;
	SingleCoeff inst = InstType.GetCoeff();
	if(inst.InstrNo!= -1)
	{
		if((inst.Acoeff!= -1)&&(inst.Bcoeff!= -1))
		{	
			double a = .001*inst.Bcoeff;
			double b = inst.Acoeff;
			double depth = a*x*x + b*x +.5;
			RetDepth = (int) depth;
		}
	}
	return RetDepth;
}

int JJVV::ComputeTailDepth()
{
	TailDepth = -1;
//	int k = ComputeLastDepth()-1;
	float DeltaT, t1,t2;

	if(!OneMeterComputed)
	{
		CompOneMeterValues();
	}

	TailDepth = OneMeter.size();
	int k=TailDepth;

	for (int i = k; i>0; i--)
	{	
		t1 = GetOneMeterValueAt(i);
		t2 = GetOneMeterValueAt(i-1);
		if(t2 == 35.5)continue;

		DeltaT = GetOneMeterValueAt(i) - GetOneMeterValueAt(i-1);
		if((DeltaT <=-0.2)|| (DeltaT >=0.1))
		{
			continue;
		}

		TailDepth = i;
//		TailDepth = i;
		TailsRem = true;
		break;
	}

	return TailDepth;
}
	


int JJVV::GetNoOfPoints()
{
	return MySeaTemp.size();
}

void JJVV::OneMeterClear()
{
	OneMeter.clear();
	OneMeterComputed = false;
}


void JJVV::OneMeterAdd(float temp)
{
		FXY22042S OneMeterVal;
	
#ifdef _WIN32
		int x = (int) (temp * pow(10,(double) OneMeterVal.GetScale())+_copysign(.5,temp))-OneMeterVal.GetOffset();
#endif
#ifndef _WIN32
		int x = (int) (temp * pow(10,(double) OneMeterVal.GetScale())+ copysign(.5,temp))-OneMeterVal.GetOffset();
#endif	
		OneMeterVal.SetValue(x);
		OneMeter.push_back(OneMeterVal);
		OneMeterComputed = true;

}



bool JJVV::CompOneMeterValues()
{
// Compute Temperatures to One Meter Intervals

	
	FXY22042S OneMeterVal;

	OneMeter.clear();
	ApplyMedianFilter();
	bool tf = false;
	if(GetNoOfPoints() > 1)
	{
		int ld = ComputeLastSmoothDepth();
		
		//+1;
		float temp;
//		for(int i=1; i < ld-1; i++)
		for(int i=1; i < ld; i++)
		{
			temp = GetSmoothTempAtDepth(i);
			if(temp!=-9999.0)
			{
#ifdef _WIN32
				int x = (int) (temp * pow(10,(double) OneMeterVal.GetScale())+_copysign(.5,temp))-OneMeterVal.GetOffset();
#endif
#ifndef	_WIN32
				int x = (int) (temp * pow(10,(double) OneMeterVal.GetScale())+copysign(.5,temp))-OneMeterVal.GetOffset();
#endif
				OneMeterVal.SetValue(x);
				OneMeter.push_back(OneMeterVal);
			}
			else
			{
				break;
			}
//			temp = GetTempAtDepth(i);

		}
		tf = true;
		OneMeterComputed = true;
	}
	return tf;
}
/*bool JJVV::CompOneMeterValues()
{
// Compute Temperatures to One Meter Intervals

	
	FXY22042S OneMeterVal;

	OneMeter.clear();
	bool tf = false;
	if(GetNoOfPoints() > 1)
	{
		int ld = ComputeLastDepth()+1;
		float temp;
		for(int i=1; i < ld; i++)
		{
			temp = GetTempAtDepth(i);
			int x = (int) (temp * pow(10,(double) OneMeterVal.GetScale())+.5)-OneMeterVal.GetOffset();
			OneMeterVal.SetValue(x);
			OneMeter.push_back(OneMeterVal);
		}
		tf = true;
		OneMeterComputed = true;
	}
	return tf;
}

*/
float JJVV::GetOneMeterValueAt(int om)
{
/*	if(om >=585)
	{
		float y=1;
	}
*/
	float x = (float) -9999;
	int nop = OneMeter.size();
	if((nop > 0) && (nop >= om) && ((om -1) >=0))
	{
		x=OneMeter.at(om - 1).GetValue().Integ;
		x = (x+OneMeter.at(om-1).GetOffset());
		x= x/pow(10.0, OneMeter.at(om-1).GetScale());
	}
	return x;
}

int JJVV::GetLastOMDepth()
{
	return OneMeter.size();
}

bool JJVV::TailsRemoved()
{
	return TailsRem;
}


bool JJVV::OneMeterComp()
{
	return OneMeterComputed;
}

void JJVV::SetInflectComp(bool value)
{
	InflectComp=value;
}
int JJVV::GetTailDepth()
{
	return TailDepth;
}
void JJVV::SetTailDepth(int tail)
{
	TailDepth=tail;
}

void JJVV::ApplyMedianFilter()
{
	int Nopts=0;
	FloatVect Pts;
	SmoothPts.clear();
//	int ip =	SmoothPts.size();
//	SmoothPts.SetSize(MySeaTemp.size());
//	ip =	SmoothPts.size();
	int i;
	for(i =1; i<(int)MySeaTemp.size()-1;i++)
	{
		int PtsSize = MySeaTemp.size()-1;
		Pts.clear();
		int i1 = Pts.size();
		if( (i-5>=0 ) && (i+5 <= PtsSize))
//		if( (i-5>=0 ) && (i+5 <= ComputeLastDepth()))
		{
			Nopts = 5;
		}
		else  if( (i-4>=0 ) && (i+4 <= PtsSize))
//		else  if( (i-4>=0 ) && (i+4 <= ComputeLastDepth()))
		{
			Nopts = 4;
		}
		else  if( (i-3 >= 0 ) && (i+3 <= PtsSize))
//		else  if( (i-3 >= 0 ) && (i+3 <= ComputeLastDepth()))
		{
			Nopts = 3;
		}
		else  if( (i-2 >= 0 ) && (i+2 <= PtsSize))
//		else  if( (i-2 >= 0 ) && (i+2 <= ComputeLastDepth()))
		{
			Nopts = 2;
		}
		else
		{
			Nopts = 1;
		}

		if(i>1561)
		{
			int ing = 8;
		}
		for (int k= i-Nopts; k <i+(Nopts+1); k++)
		{
			Pts.push_back(GetTempAtPos(k));
		}

		float f = GetMedian(&Pts);
	SmoothPts.push_back(GetMedian(&Pts));
	}

		for (i=(int)SmoothPts.size()-1; i>1; i--)   // Paul's Error
		{
			float temp = SmoothPts.at(i);
			if((temp >= 35.5)) //||(temp <-1.9))
			{
//				SmoothPts.RemoveAt(i);
				SmoothPts.erase(SmoothPts.begin()+i);
				continue;
			}
			break;
		}
	Smoothed = true;
}


bool JJVV::ComputeInflectionPoints()
{

	// Apply Median Filter

	DepTemp IPdata;	
	InflectComp = false;
	if(ComputeLastDepth()<5)
	{
		return InflectComp;
	}

	if(!Smoothed)
	{
		ApplyMedianFilter();
	}

	int td = ComputeTailDepth();
/*	TRY
{	
	MyfileO.Open("D:\\development\\seas\\SmoothPoints.txt",CFile::modeWrite|CFile::typeText|CFile::modeCreate );//;

}
CATCH( CFileException, e )
{
   #ifdef _DEBUG
      afxDump << "File could not be opened "
              << e->m_cause << "\n";
   #endif
}
END_CATCH

	char aout[100];
	int npts = SmoothPts.size();
	for ( i = 0; i < npts; i++)
	{
//		SmoothPts.at(i);
		float ip = GetDepthAtPos(i);
		float it = SmoothPts.at(i);
//		sprintf(aout,"%5.2f,  %7.2f\n",ip,it);
//		MyfileO.WriteString(aout);

//		cout << "\n"<< i  <<fm63.GetOneMeterValueAt(i) << flush;
	}
MyfileO.Close();
*/
//	float q= (float) 0.010;
	float q= (float) 0.15;

	while(q<2.0) //910
	{
		bool CompNewLimits = false;
		Inflection.clear();
//		float t1 = SmoothPts.at(2);
//		float d1 = GetDepthAtPos(2);

		float t1 = GetSmoothTempAtDepth(2);
		float d1 =2.0;
		IPdata.Temp = t1;
		IPdata.Depth = (int) (d1);
//		IPdata.Depth = (int) (d1+.5);
		Inflection.push_back(IPdata);

		float t2 = GetSmoothTempAtDepth(3);
		float d2 = 3.0;
//		float d2 = GetDepthAtPos(3);
		float deltat = t2-t1;
		float deltad = d2-d1;
		float lsr = (deltat + q)/deltad;  // right limiting slope
		float lsl = (deltat - q)/deltad;	 // Left limiting slope
//		for( int i=4; i< SmoothPts.size(); i++) //930
//		for( int i=4; i< ComputeLastSmoothDepth(); i++) //930
		int i;
		for( i=4; i< td; i++) //930
		{
//			t1 = t2;
//			d1 = d2;
			t2 = GetSmoothTempAtDepth(i);
//			d2 = GetDepthAtPos(i);
			d2 = i;
			if(d1 > td)
			{
				break;
			}
			float Ndeltat = t2-t1;
			float Ndeltad = d2-d1;
			if(CompNewLimits)
			{
				lsr = (Ndeltat + q)/Ndeltad;
				lsl = (Ndeltat - q)/Ndeltad;
				CompNewLimits = false;
			}

			float Tslope =  Ndeltat/Ndeltad;
			if(Tslope > lsr)
			{
				IPdata.Temp = t2;
				IPdata.Depth = (int) (d2);
//				IPdata.Depth = (int) (d1+.5);
				t1 = t2;
				d1=d2;
				Inflection.push_back(IPdata);
				CompNewLimits = true;
				continue;
			}

			if(Tslope < lsl)
			{
				IPdata.Temp = t2;
				IPdata.Depth = (int) (d2);
//				IPdata.Depth = (int) (d1+.5);
				t1 = t2;
				d1=d2;
				Inflection.push_back(IPdata);
				CompNewLimits =  true;
				continue;
			}
			Tslope = (Ndeltat+q)/Ndeltad;
			if(Tslope < lsr)
			{
				lsr = Tslope;
			}

			Tslope = (Ndeltat-q)/Ndeltad;
			if(Tslope > lsl)
			{
				lsl = Tslope;
			}



		}
		
		int nif = Inflection.size();
//		if(Inflection.size()< MAXINFPTS-1)
		if(Inflection.size()< MAXINFPTS)
		{
			InflectComp = true;

			IPdata.Temp = GetSmoothTempAtDepth(td);
			IPdata.Depth = td;  //(int) (GetDepthAtPos(SmoothPts.size()-1)+.5);
			Inflection.push_back(IPdata);
			int i;
			for(i=0;i<Inflection.size()-1;i++)
			{
				DepTemp First, Next;
				First = Inflection.at(i);
				Next = Inflection.at(i+1);
				if(First.Depth == Next.Depth)
				{
					Inflection.erase(Inflection.begin() + (i+1));
				}
			}
			int k= Inflection.size();
			for(i=0; i<k-2; i++)
			{
				DepTemp First, Secnd, Last;
				First = Inflection.at(i);
				while(1)
				{
					if((i+2) <= (k-1))
					{
						Secnd = Inflection.at(i+1);
						Last = Inflection.at(i+2);
					}
					else
					{
						break;
					}

					int t1,t2,t3;
					t1 = (int)((First.Temp+.05)*10.0);
					t2 = (int)((Secnd.Temp+.05)*10.0);
					t3 = (int)((Last.Temp+.05)*10.0);

					if((t1 == t2)&& (t2 == t3))
					{
						Inflection.erase( Inflection.begin() + (i+1));
						k = Inflection.size();
					}
					else
					{
						break;
					}
				}

				if((i+2) <= (k-1))
				{
					continue;
				}
				else
				{break;}

			}

			return InflectComp;
		}
		else
		{
//			q=q*1.05;
			q=q*1.10;
		}
	}


	return InflectComp;
}


float JJVV::GetMedian(FloatVect *pts)
{

	FloatVect mytemps;

	for (int i=0; i<pts->size();i++)
	{
		float x = pts->at(i);
		mytemps.push_back(x);
	}


/*	for (i=0; i< mytemps.size()-1;i++)
	{

		for (int j=i+1; j<mytemps.size(); j++)
		{
				float b = mytemps.at(j);
			if(mytemps.at(i) < mytemps.at(j))
			{
				float a = mytemps.at(j);
				mytemps.SetAt(j, mytemps.at(i));
				mytemps.SetAt(i,a);
			}

		}

	}

*/
	sort(mytemps.begin(), mytemps.end());
	return mytemps.at(mytemps.size()/2);
}

int JJVV::GetNumInflectPts()
{
	return Inflection.size();
}

DepTemp JJVV::GetInfPointAt(int pos)
{
	if(pos<Inflection.size())
	{
		return Inflection.at(pos);
	}
	else
	{
		DepTemp x ={ NULL, NULL};
		return x;
	}
}

unsigned long JJVV::GetUniqueTag()
{
	unsigned long tag;
	tag = UniqueTag.GetValue().Integ;
	string Y = UniqueTag.GetValue().StrVal;
//	cout << "StrVal is " << Y << endl;
	
//	cout << "tag is " << tag << endl;
	return tag;
}

int JJVV::GetNumOfSmoothPoints()
{
	return SmoothPts.size();
}

FDepTemp JJVV::GetSmoothPointAt(int x)
{
	FDepTemp A;
	A.Temp = (float)-9999;
	A.Depth = -9999;
	if(x <= GetNumOfSmoothPoints()-1)
	{
		A.Depth = GetDepthAtPos(x);//+.5;
		A.Temp = SmoothPts.at(x);
	}
	return A;
}


bool JJVV::EnoughToXmit()
{
	bool RetVal = false;
	if(WMO_ID.IsValid() && 
		Lat.IsValid() && Lon.IsValid() && Year.IsValid() &&
		Month.IsValid() && Day.IsValid() && Hour.IsValid() &&
		Minute.IsValid())
	{
		RetVal = true;
	}
	return RetVal;
}

RetMess  JJVV::BuildBinMess(int DataType)
{
	RetMess x;
	x.Mess = NULL;
	x.size = NULL;
	SetBitPos = 0;
	if(BinaryMess != NULL)
	{
		delete [] BinaryMess;
		BinaryMess=NULL;
	}
	int CompMess;
	FM94Elem *y;
	char* z;
	int NumBits;
	int numbytes = 0;
	if(EnoughToXmit())
	{
		if(DataType==1)
		{
			NoRepFields.SetValue(1);
			TimesReplicated.SetValue(GetNoOfPoints());
			CompMess= MessSize + SeaTemp.GetMaxBits() * GetNoOfPoints();
		}
		else if(DataType==2)
		{
			NoRepFields.SetValue(1);
			TimesReplicated.SetValue((int)(OneMeter.size()/2));
			CompMess= MessSize + SeaTemp.GetMaxBits() * (OneMeter.size()/2);
		}
		else if(DataType==3)
		{
			NoRepFields.SetValue(2);
			TimesReplicated.SetValue((int)Inflection.size());
			CompMess= MessSize + (SeaTemp.GetMaxBits()+SeaDepth.GetMaxBits()) * Inflection.size();
		}
		int SaveValue = ThisDataIs.GetValue().Integ;
		ThisDataIs.SetValue(DataType);
		numbytes = CompMess/8;
		if(CompMess % 8 !=0)numbytes++;  // add one byte if there are excess bits
		BinaryMess = new char[numbytes];
		int i;
		for (i=0; i< numbytes; i++)
		{
			BinaryMess[i]=(char)255;
		}
//	Add in the Generic SEASOB Info
		for ( i=0; i< SEAS_Elem.size(); i++)
		{
/*			if(i==17)
			{
				printf("I = 17 in BuildBin");
			}
*/
			y = (FM94Elem *) SEAS_Elem.at(i);
//			z =	y->GetBufrVal();
			z =	y->GetBufrVal();
			NumBits = y->GetMaxBits();

		// Check if a particular bit is set in the value

			for(int j = 1;j < NumBits+1; j++)
			{
				if(CheckBit(j,z))
				{
					SetBit(SetBitPos+j,1,BinaryMess);
/*
					if(i==17)
					{
						printf("setting bit %d to 1\r\n",(SetBitPos+j));
					}
*/
				}
				else
				{
					SetBit(SetBitPos+j,0,BinaryMess);
/*					if(i==17)
					{
						printf("setting bit %d to 0\r\n",(SetBitPos+j));
					}
*/
				}

			}
			SetBitPos += NumBits;
		}

		//  Now Add in the JJVV specific Info

		if(DataType == 1)
		{
			// Message to contain 10hz raw temperatures 
			for (i=0; i < MySeaTemp.size(); i++)
			{
				y = (FM94Elem *) &MySeaTemp.at(i);
				z =	y->GetBufrVal();
				int z1 = MySeaTemp.at(i).GetValue().Integ;
				NumBits = y->GetMaxBits();

		// Check if a particular bit is set in the value

				for(int j = 1;j < NumBits+1; j++)
				{
					if(CheckBit(j,z))
					{
						SetBit(SetBitPos+j,1,BinaryMess);
					}
					else
					{
						SetBit(SetBitPos+j,0,BinaryMess);
					}

				}
			SetBitPos += NumBits;
			}


		}
		else if(DataType == 2)
		{
			// message to contain two meter data.

			for (i=1; i < OneMeter.size(); i+=2)
			{
				y = (FM94Elem *) &OneMeter.at(i);
				z =	y->GetBufrVal();
				int z1 = OneMeter.at(i).GetValue().Integ;
				NumBits = y->GetMaxBits();

		// Check if a particular bit is set in the value

				for(int j = 1;j < NumBits+1; j++)
				{
					if(CheckBit(j,z))
					{
						SetBit(SetBitPos+j,1,BinaryMess);
					}
					else
					{
						SetBit(SetBitPos+j,0,BinaryMess);
					}

				}
			SetBitPos += NumBits;
			}


		}
		else if(DataType == 3)
		{
			// Message to contain flexure point depth/temperature pairs.
			int x;
			FXY22042S y;
			float k;

			for (i=0; i < Inflection.size(); i++)
			{

				SeaDepth.SetValue(Inflection.at(i).Depth);
				k = Inflection.at(i).Temp;
				x = (int) (k * pow(10,(double) y.GetScale())+.5)-y.GetOffset();
				SeaTemp.SetValue(x);				
//				y = (FM94Elem *) &Inflection.ElementAt(i);
//				z =	y->GetBufrVal();
				z = SeaDepth.GetBufrVal();
//				int z1 = SeaDepth.at(i).GetValue().Integ;
				NumBits = SeaDepth.GetMaxBits();

		// Check if a particular bit is set in the value
		// First the Depth
				int j;
				for(j = 1;j < NumBits+1; j++)
				{
					if(CheckBit(j,z))
					{
						SetBit(SetBitPos+j,1,BinaryMess);
					}
					else
					{
						SetBit(SetBitPos+j,0,BinaryMess);
					}

				}
			SetBitPos += NumBits;
		// Check if a particular bit is set in the value
		// Next the Temperature

				z = SeaTemp.GetBufrVal();
				NumBits = SeaTemp.GetMaxBits();
				for( j = 1;j < NumBits+1; j++)
				{
					if(CheckBit(j,z))
					{
						SetBit(SetBitPos+j,1,BinaryMess);
					}
					else
					{
						SetBit(SetBitPos+j,0,BinaryMess);
					}

				}
			SetBitPos += NumBits;
			}


		}
		ThisDataIs.SetValue(SaveValue);



		
	}

	x.Mess = BinaryMess;
	x.size = numbytes;
	return x;
}

bool JJVV::CheckBit(int bitno,  char *InVal)
{

	bool RetVal = false;
	int ByteOff = bitno/8;
	int Bit2Set = -( bitno % 8)+8 ;
	if(Bit2Set == 8)
	{
		Bit2Set=0;
		ByteOff -=1;
	}
	char BitMask = (char)( pow(2,(double)Bit2Set) );

	char byte = InVal[ByteOff];
	if( byte & BitMask)
	{RetVal=true;}
	return RetVal;
}


void JJVV::SetBit(int bitno, char value, char * InVal)
{
	int ByteOff = bitno/8;
	int Bit2Set = -( bitno % 8) + 8 ;
	if(Bit2Set == 8)
	{
		Bit2Set=0;
		ByteOff -=1;
	}
	_int8 BitMask = ~(_int8)( pow(2,(double)Bit2Set) ) | ((_int8)( pow(2,(double)Bit2Set) )) * value;
	InVal[ByteOff] = InVal[ByteOff] & BitMask;
//	printf("%d /n",BBXXmess[ByteOff]);
}


bool JJVV::DecodeBinMess(RetMess *InMess)
{
	FM94Elem *y;
//	FM94Value z;
	FXY7062S Dpt;
	FXY22042S tmp, tmp1;
	DepTemp inf;
//	int size;
	int i;



//	SEAS_Elem.erase(SEAS_Elem.begin() +No_SEASOBS_Elements ,SEAS_Elem.end());

		int iii = SEAS_Elem.size();


/*	SEAS_Elem.push_back(&ShipName);
	SEAS_Elem.push_back(&Lloyds);
//	FXY48301 CruiseName;
	SEAS_Elem.push_back(&UniqueTag);
	SEAS_Elem.push_back(&SEASVersion);
	SEAS_Elem.push_back(&ProbeSerial);
	SEAS_Elem.push_back(&ThisDataIs);
	SEAS_Elem.push_back(&DataQual);
	SEAS_Elem.push_back(&InstType);
	SEAS_Elem.push_back(&RecorderType);
	SEAS_Elem.push_back(&TypeWindInst);
	SEAS_Elem.push_back(&WindDir);
	SEAS_Elem.push_back(&WindSpeed);
	SEAS_Elem.push_back(&DryBulbTemp);
	SEAS_Elem.push_back(&CurrMeasMeth);
	SEAS_Elem.push_back(&CurrentDir);
	SEAS_Elem.push_back(&CurrentSpeed);
	SEAS_Elem.push_back(&TotalWaterDepth);
	SEAS_Elem.push_back(&NoRepFields);
	SEAS_Elem.push_back(&TimesReplicated);
//	SEAS_Elem.push_back(&SeaTemp);
//	SEAS_Elem.push_back(&SeaDepth);
*/
	BitPos = 0;

	if(	BinaryMess != NULL)
	{
		delete [] BinaryMess;
		BinaryMess = NULL;
	}

	TailsRem = false;
	OneMeterComputed = false;
	TailDepth = -1;
	InflectComp = false;

	Inflection.clear();
	MySeaTemp.clear();
	OneMeter.clear();
	RawSeaTemp.clear();

	//  Decode the General SEASOB Information..


	int Elements_Now = SEAS_Elem.size();


// Decode all of the general SEASOB Meta Info

	if(!DecodeElements(0,No_SEASOBS_Elements, InMess, &BitPos))
	{
		return false;
	}

// Decode the JJVV Meta Info
	if(!DecodeElements(No_SEASOBS_Elements,Elements_Now-No_SEASOBS_Elements, InMess, &BitPos))
	{
		return false;
	}

	if(ThisDataIs.GetValue().Integ == 1)  // Full resolution profile being decoded
	{
		for(i=0; i< TimesReplicated.GetValue().Integ;i++)
		{
			if(!DecodeElements(InMess, &BitPos, &tmp))
			{
				return false;
			}
			else
			{
				MySeaTemp.push_back(tmp);
				float x=tmp.GetValue().Integ;
				x = (x+tmp.GetOffset())/pow(10.0, tmp.GetScale());
				RawSeaTemp.push_back(x);
			}

		}
	}
		/* two meter data being decode therefore populate onemeter vector with two copies
		of the two meter element.  This provide compatibility of other routins that use the onemeter vector.
		We are basically using an even two meter value to also represent the previous odd value
		*/
	else if(ThisDataIs.GetValue().Integ == 2) 
	{
		for(i=0; i< TimesReplicated.GetValue().Integ;i++)
		{
			if(!DecodeElements(InMess, &BitPos, &tmp))
			{
				return false;
			}
			else
			{
				OneMeterComputed=true;
				OneMeter.push_back(tmp);
				OneMeter.push_back(tmp);
			}
		}
	}
	else if(ThisDataIs.GetValue().Integ == 3)
	{
		for(i=0; i< TimesReplicated.GetValue().Integ;i++)
		{
			for(int k=0; k<2; k++)
			{
				if(k==0)
				{
					y = (FM94Elem *) &Dpt;
				}
				else
				{
					y = (FM94Elem *) &tmp;
				}

					if(!DecodeElements(InMess, &BitPos, y))
					{
						return false;
					}
			}
					 
			inf.Depth = Dpt.GetValue().Integ;
			float x=tmp.GetValue().Integ;
			x = (x+tmp.GetOffset())/pow(10.0, tmp.GetScale());
			inf.Temp = x;
			Inflection.push_back(inf);
		}
	}



	return true;
}


void JJVV::CleanUpRawData()
{
	if(MySeaTemp.size()>0)
	{
		ThisDataIs.SetValue(1);

		for (int i = 0; i< MySeaTemp.size()-21; i++)   // Paul's Error
		{
			float temp = GetTempAtPos(i);
			float temp10 = GetTempAtPos(i+20);
			if(((temp >= 35.5) && (temp10 >= 35.5)) || ((temp <-2.5) && (temp10 <-2.5)))
			{
				int siz = MySeaTemp.size();
				int rem = siz-(i+1);
				MySeaTemp.erase(MySeaTemp.begin()+i,MySeaTemp.end());
//				continue;
				break;
			}
//			break;
		}
		
/*#ifndef _WIN32
		int i;
#endif*/
		for(int i = MySeaTemp.size()-1; i>0;i--)
		{
			float temp = GetTempAtPos(i);
			if((temp >= 35.5) || (temp <-2.5))
			{
				MySeaTemp.erase(MySeaTemp.begin()+i);
			}
			else
			{break;}
		}

	}
}
string JJVV::BuildJJVVMess(int Type)
{
	int x=0;
	string Return = "JJVV ";
	string mess;

	string crcrlf = "\r\n";
//	crcrlf.at((0,13);
//	crcrlf.SetAt(1,10);
//	crcrlf.SetAt(2,10);
//	crcrlf.SetAt(3,0);
	char *token;
	char *save;
	int cut = 6;

//	format("%2.2d",Day.GetValue().Integ);
	mess = format("%2.2d",Day.GetValue().Integ);
	Return += mess;
	mess = format("%2.2d",Month.GetValue().Integ);
	Return += mess;
	mess = format("%1.1d ",Year.GetValue().Integ%10);
	Return += mess;
	mess = format("%2.2d",Hour.GetValue().Integ);
	Return += mess;
	mess = format("%2.2d/ ",Minute.GetValue().Integ);
	Return += mess;
	if(GetQuadrant() != -1)
	{
		mess = format("%1.1d",GetQuadrant());
		Return += mess;
		float  mylat = GetLat();
		mess = format("%5.5d ", (int) ((fabs(GetLat()*10000)+ 5)/10));
		Return += mess;
//		format("%6.6d ", (int) abs((GetLon()*1000+.5)));
		float mylon = GetLon();
		double myflon = fabs(GetLon()*10000);
		myflon += 5;
		myflon/=10;
		int myiflon = (int) myflon;
		mess = format("%6.6d ", (int) ((fabs(GetLon() *10000) + 5)/10));
		Return += mess;
	}
	else
	{
		Return = "";
		return Return;
//		return (int) 1;
	}

	if((GetTypeWindInst()!=-1) || (GetWindDir()!=-1) || (GetWindSpeed()!=-1))
	{
		int x = GetTypeWindInst();
		char iu;
		int dd;
		int ff;
	/*		{0,"Uncertified Instruments meters/sec"},
			{1,"Certified Instruments meters/sec"},
			{2,"Uncertified Instruments knots"},
			{3,"Certified Instruments knots"},
			{4,"Uncertified Instruments kilometers/hour"},
			{5,"Certified Instruments kilometers/hour"}
	*/
		if(x==1)
		{iu='0';}
		else if(x==3)
		{iu='1';}
		else if(x==2)
		{iu='3';}
		else if(x==0)
		{iu='2';}
		else
		{iu = '3';}
		mess = format("%c", iu);
		Return += mess;

		dd = GetWindDir();
		if( dd != -1)
		{
			mess = format("%2.2d", dd/10);
			Return += mess;
		}
		else
		{
			Return+="//";
		}


		ff = (int) GetWindSpeed();
		if( ff != -1)
		{
			ff= (int) (GetWindSpeed()+.5);
			mess = format("%2.2d ", ff);
			Return += mess;
		}
		else
		{
			Return+="// ";
		}
	}

	if(GetDryBulbTemp() != -9999.0)
	{
		int isg = 0;
		if(GetDryBulbTemp() <0)
		{
			isg=1;
		}
		float DryBT = GetDryBulbTemp()*10.0;
		if(isg == 1)
		{
			DryBT= (-DryBT)+0.5;
		}
		else
		{
			DryBT= DryBT + 0.5;
		}
		mess = format("4%1.1d%3.3d ",isg,(int)(DryBT));
//		mess = format("4%1.1d%3.3d ",isg,fabs(GetDryBulbTemp()*10));
		Return += mess;
	}

	Return += "8888";
	if(Type == 1)
	{
		Return+="7 ";
	}
	else if(Type == 2)
	{
		Return+="8 ";
	}

	if(GetInstType() != -1)
	{
		mess = format("%3.3d", GetInstType());
		Return += mess;
	}
	else
	{
		Return += "///";
	}

	if(GetRecorderType() != -1)
	{
		mess = format("%2.2d ", GetRecorderType());
		Return += mess;
	}
	else
	{
		Return += "// ";
	}

//	MySeaTemp.clear();
	if((GetDataType() == 1)&&(!InflectComp))
	{
		ComputeInflectionPoints();
	}

	int tdept = GetTailDepth(); 

	if(Type == 1)
	{
		if(GetDataType()==2)OneMeterComputed=true;
		if(OneMeterComp())
		{
//			ComputeTailDepth();
//			for( int i=2; i<OneMeter.size()-1;i+=2)
			int TailCutoff =0;
			if(GetDataType()==1)
			{
				TailCutoff=GetTailDepth();
			}
			else if(GetDataType()==2)
			{
				TailCutoff=OneMeter.size()-1;
			}

//			for( int i=2; i<=GetTailDepth();i+=2)
			for( int i=2; i<=TailCutoff;i+=2)
			{
#ifdef _WIN32
				int temp = GetOneMeterValueAt(i)*10 + _copysign(.5,GetOneMeterValueAt(i));
#endif
#ifndef _WIN32
				int temp = (int) (GetOneMeterValueAt(i)*10 + copysign(.5,GetOneMeterValueAt(i)));
#endif				

				//				int temp = GetOneMeterValueAt(i)*10;
				if(temp<0)
				{
					temp = abs(temp)+500;
				}

				if((i)%100 == 0)
				{
						mess = format("999%2.2d ", (i)/100);
						Return+=mess;
				}
				mess = format("%2.2d%3.3d ",(i)%100, temp);
				Return+=mess;
			}
		}

	}
	else if(Type == 2)
	{
		int depth;
		int temp;
		int hund = 0;
		
		for (int i=0; i<Inflection.size(); i++)
		{
			depth = (int) Inflection.at(i).Depth;
//			float ttemp = Inflection.at(i).Temp*10;
//			temp = Inflection.at(i).Temp*10+_copysign(.5,Inflection.at(i).Temp);
			temp = (int) Inflection.at(i).Temp*10;
			if(temp<0)
			{
				temp = (int)(abs(temp)+500); 
			}
			if(depth/100 != hund)
			{
				hund = depth/100;
				mess = format("999%2.2d ", hund);
				Return+=mess;
/*				if(Return.GetLength()%65 <= cut)
				{
					Return.Delete(Return.GetLength()-1,1);
					Return+=crcrlf;
				}*/
			}
			mess = format("%2.2d%3.3d ",depth%100, temp);
			Return+=mess;
/*			if(Return.GetLength()%65 <= cut)
			{
				Return.Delete(Return.GetLength()-1,1);
				Return+=crcrlf;
			}*/
		}
	}
	
	// 66666 group
	bool SixSet = false;
	int a = GetTotalWaterDepth();
	int b = GetCurrentDir();
	int c = (int) GetCurrentSpeed();
	if(GetTotalWaterDepth() != -1)
	{
		Return += "66666 ";
		SixSet=true;

		mess = format("1%4.4d ", GetTotalWaterDepth());
		Return += mess;
	}

		string hold ="";
		if((GetCurrMeasMeth()!= -1) && (GetCurrMeasMeth() != 0) && (GetCurrMeasMeth() != 6)) 
		{
			mess = format("%1.1d", GetCurrMeasMeth());
			hold += mess;
		}
		else
		{
			hold += "/";
		}

		if(GetCurrentDir()!=-1)
		{
			mess = format("%2.2d", (int)(((float)GetCurrentDir())/10+.5));
			hold += mess;
		}
		else
		{
			hold += "//";
		}

		if((GetCurrentSpeed() != -1) && (GetCurrentSpeed() <10.0))
		{
			int spd = (int) (GetCurrentSpeed()*10);
			mess = format("%2.2d ",spd);
			hold += mess;
		}
		else
		{
			hold +="// ";
		}

		if(hold.compare("///// ") != 0)
		{
			if(!SixSet)
			{
				Return += "66666 1//// ";
			}

			Return += hold;
		}

/*		if(Return.GetLength()%65 <= cut)
		{
			Return.Delete(Return.GetLength()-1,1);
			Return+=crcrlf;
		}*/


	Return += GetWMO_ID()+"=";

	save = new char[Return.length()+1];
//	int ip = 
	strcpy(save, Return.c_str());
	save[Return.length()]='\0';

	token = strtok(save," ");
	mess="";
	mess += token;
	mess += " ";
	int i = 1;
	while(token != NULL)
	{
		token = strtok(NULL," ");
		if(token==NULL){continue;}
		mess += token;
		i++;

		if(i==470)
		{
			int jj=1;
		}
		if(i%10 == 0)
		{
			mess+=crcrlf;
		}
		else
		{
			mess+=" ";
		}
	}

	int j = mess.length();
	delete [] save;
	return mess;
//	return (int) 1;
}

bool JJVV::DecodeSEASIVJJ(RetMess *InMess, int mon, int day, int year)
{

	int MyDay;
	int ihr ;
	int imin;
	struct SEASIVPars
	{
		int offset;
		int min;
		int nobits;
		int max;
		int scale;
	};

	TailsRem = false;
	OneMeterComputed = false;
	TailDepth = -1;
	InflectComp = false;

	Inflection.clear();
	MySeaTemp.clear();
	OneMeter.clear();
	RawSeaTemp.clear();

	SetMessType(1);  // JJVV Message

	if(InMess->size < 18)
	{return false;}

// Get the call sign from the record and set in JJVV object.
	char CallSign[10];

   memcpy(CallSign,InMess->Mess,9);
	int i;
   for(i=8;i>0;i--)
   {
	   if(CallSign[i]==' ')
	   {
		   CallSign[i] = '\0';
	   }
	   else
	   {
		   break;
	   }
   }
   CallSign[9]='\0';
   WMO_ID.SetValue(CallSign);
//  CString x =  WMO_ID.GetValue().StrVal;

   unsigned IMsatSub=0;
   for( i = 73; i<79; i++)
   {
	   IMsatSub = (IMsatSub << 1) | (unsigned) CheckBit(i,InMess->Mess);
   }

   unsigned MinofMon=0;
   for( i = 79; i<95; i++)
   {
		MinofMon = (MinofMon << 1) | (unsigned) CheckBit(i,InMess->Mess);
   }

 //  bool x1 = ((MinofMon & 0xFFFF)==-1);
  // bool x2 = (MinofMon < -44640);
   if(MinofMon > 44640)
	{
		return false;
	}

    MyDay = MinofMon / 1440 +1;
	ihr = (MinofMon % 1440)/60;
	imin = MinofMon  % 60;

	if(MyDay > day)
	{
		mon-=1;
		if(mon==0)
		{
			mon = 12;
			year -=1;
		}
	}
	tm obtime;
	obtime.tm_year = year+100;
	obtime.tm_mon = mon-1;
	obtime.tm_mday = MyDay;
	obtime.tm_hour = ihr;
	obtime.tm_min = imin;


//	Get the Latitude
	unsigned ilat = 0;
	for( i = 95; i<110; i++)
	{
		ilat = (ilat << 1) | (unsigned) CheckBit(i,InMess->Mess);

	}

	if((ilat | 0x8000) == 0xFFFF)
	{
		return false;
	}
	int lat = (int)ilat - 9000;
	SetLat((double) lat/100.0);

// Get The Longitude
	unsigned ilon = 0;
	for( i = 110; i<126; i++)
	{
		ilon = (ilon << 1) | (unsigned) CheckBit(i,InMess->Mess);

	}

	if(ilon == 0xFFFF) // check if all ones
	{
		return false;
	}
//	ilat -=9000;
	int lon = (int)ilon - 18000;
	SetLon((double) lon/100.0);
	double ll = GetLon();

	int quad = GetQuadrant();

//  Get Instrument Type
	unsigned irec = 0;
	for( i = 126; i<136; i++)
	{
		irec = (irec << 1) | (unsigned) CheckBit(i,InMess->Mess);

	}

	if((irec | 0xFC00) == 0xFFFF) // check if all ones
	{
		return false;
	}
	int rec = (int)irec;
	SetInstType(rec);

//  Get Recorder Type
	irec = 0;
	for( i = 136; i<143; i++)
	{
		irec = (irec << 1) | (unsigned) CheckBit(i,InMess->Mess);

	}

	if((irec | 0xFF80) == 0xFFFF) // check if all ones
	{
		return false;
	}
	   rec = (int)irec;
	SetRecorderType(rec);

//  Get Number of Inflection Points
	unsigned ipoints = 0;
	for( i = 143; i<148; i++)
	{
		ipoints = (ipoints << 1) | (unsigned) CheckBit(i,InMess->Mess);

	}

	 int NoPoints = (int)ipoints;
//	SetRecorderType(rec);

	 if(NoPoints > 29)
	 {return false;}
	
	int bitpos = 148;
	for (int j = 0; j<NoPoints; j++)
	{
		if((bitpos + 20)/8 > InMess->size)  // not enough bytes in message
		{return false;}

		unsigned idepth = 0;
		for( i = bitpos; i< (bitpos +11); i++)
		{
			idepth = (idepth << 1) | (unsigned) CheckBit(i,InMess->Mess);

		}

		int depth = (int)idepth;
		bitpos+=11;

		unsigned itemp = 0;
		for( i = bitpos; i< (bitpos +9); i++)
		{
			itemp = (itemp << 1) | (unsigned) CheckBit(i,InMess->Mess);

		}

		int temp  = (int)itemp - 2682;
		bitpos+=9;
	}


	return true;
}

bool JJVV::DecodeJJVV(string Ob)
{
	char *string;
	char *token;
	time_t local_time;
	tm *now; //gmtime()
	time(&local_time);
	now = gmtime(&local_time);
	// Assumes year is for this decade 
	Inflection.clear();
	InflectComp = false;
	Tokens.clear();
	int jjvv = Ob.find("JJVV");
	if(jjvv<0)
	{return false;}

	std::string Sub = Ob.substr(jjvv);
	string = new char[Sub.length()+1];
	strcpy(string,Sub.c_str());
	token = strtok(string," \t\n\r");
	if(token != NULL)
	{
		std::string Push_Token = token;
		Tokens.push_back(Push_Token);
	}

	while(token != NULL)
	{
		token = strtok(NULL," \t\n\r");
		if(token == NULL)
		{break;}
		Tokens.push_back(token);
	}

	delete [] string;

	std::string CS = Tokens.at(Tokens.size());
	int notok = Tokens.size();
	int year, month, day, hour, min;
	int ThisYr = now->tm_year+1900;
// Element [0] is the JJVV element MiMiMjMj

	if(Tokens.size() >= 1)  // make sure that token exists in array
	{
		if(sscanf(Tokens.at(1).c_str(),"%2d%2d%1d",&day, &month, &year)==3)
		{
			int Diff = ThisYr%10;
			if(Diff >= year)
			{
				ThisYr = ThisYr +(year-Diff);
			}
			else
			{
				ThisYr = ThisYr -10 +(year-Diff);
			}
		}
		else 
		{
			return false;
		}
	}
	else 
	{
		return false;
	}
//
	if(Tokens.size() >= 2)  // make sure that token exists in array
	{
		if(sscanf(Tokens.at(2).c_str(),"%2d%2d%1d",&hour, &min)==2)
		{
			tm Obtime;
			Obtime.tm_mon = month-1;
			Obtime.tm_mday = day;
			Obtime.tm_year = ThisYr - 1900;
			Obtime.tm_hour = hour;
			Obtime.tm_min = min;
			SetObtime(Obtime);
		}
		else 
		{
			return false;
		}
	}
	else 
	{
		return false;
	}

	_int8 quad, lastchar;
	double lat;
	int ilat;
	if(Tokens.size() >= 3)  // make sure that token exists in array
	{
		if(sscanf(Tokens.at(3).c_str(),"%1c%4d%c",&quad, &ilat, &lastchar)==3)
		{
			lat = ilat;
			if(lastchar=='/')
			{
				lat/=100.0;
			}
			else
			{
				lat*=10;
				lat += (lastchar-48);
				lat/=1000.0;
			}
			if((quad=='5')||(quad=='3'))
			{lat*=-1;}
			SetLat(lat);
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}

	double lon; 
	int ilon;
	if(Tokens.size() >= 4)  // make sure that token exists in array
	{
		if(sscanf(Tokens.at(4).c_str(),"%5d%c",&ilon, &lastchar)==2)
		{
			lon=ilon;
			if(lastchar=='/')
			{
				lon/=100.0;
			}
			else
			{
				lon*=10;
				lon += (lastchar-48);
				lon/=1000.0;
			}
			if((quad=='5')||(quad=='7'))
			{lon*=-1;}
			SetLon(lon);
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}

	char k1 = '\0';
	for (int TP =5; TP <8; TP++)
	{
	//	int TokPos = 5;
		int TokPos = TP;
		if(Tokens.size() >= TP)  // make sure that token exists in array
		{
			if(Tokens.at(TokPos).find("8888")==0) //
			{
				TokPos = Proc8Group(TokPos, &k1, &Tokens);
				if(Tokens.at(TokPos).find("66666")==0)
				{
					Proc6Group(TokPos, &Tokens);
					return true;
				}
				else if(Tokens.at(TokPos).find("99999")==0)
				{
					//	This is a buoy.  Next Token is the wmo id
					if(Tokens.size() >= TokPos+1)
					{
						std::string tok1 = Tokens.at(TokPos+1);
						if((tok1.at(tok1.length()-1) == '=') &&(tok1.length() > 0))
						{
							// This is a Call Sign
							tok1.erase(tok1.length()-1,1);
							SetWMO_ID((char *) tok1.c_str());
							return true;
						}
					}
				}
				else
				{
					int pic = Tokens.size();
					int pic2 = TokPos+1;
					if(TokPos == Tokens.size())
					{

						std::string tok1 = Tokens.at(TokPos);
						if(tok1.length()>1)
						{
							if((tok1.at(tok1.length()-1) == '=') &&(tok1.length() > 1))
							{
								// This is a Call Sign
								tok1.erase(tok1.length()-1,1);
								SetWMO_ID((char *) tok1.c_str());
							//	int pic = tok1.GetLength();
							//	int pic2 = 
								return true;
							}
							else
							{
								SetWMO_ID((char *) Tokens.at(TokPos).c_str());
							}
						}
					}
					else if((TokPos+1 == Tokens.size())&& (Tokens.at(TokPos+1).compare("=")==0))
					{
						SetWMO_ID((char *) Tokens.at(TokPos).c_str());
						return true;
					}

				}

			}
			else if((Tokens.at(TokPos).at(0) >= '0') && (Tokens.at(TokPos).at(0) <= '3'))
			{
				int ind = -1;
				int wd = -1;
				int ws = -1;
				if(sscanf(Tokens.at(TokPos).c_str(),"%1d%2d%2d", &ind, &wd, &ws)==3)
				{
	//				SetTypeWindInst(ind)
					SetWindDir(wd*10);
					if((ind == 0)|| (ind == 2))
					{
						float wsknts = (float) ws *3600.0/1852.0;
						SetWindSpeed(wsknts);
						if(ind == 0)
						{
							SetTypeWindInst(1);
						}
						else
						{
							SetTypeWindInst(0);
						}
					}
					else
					{
						SetWindSpeed((float) ws);
						if(ind == 1)
						{
							SetTypeWindInst(3);
						}
						else
						{
							SetTypeWindInst(2);
						}
					}



				}
				continue;
			}
			else if((Tokens.at(TokPos).at(0) >= '4'))
			{
				int ind = -1;
				int sgn = -1;
				float AirTemp = -1.0;
				std::string tok1 = Tokens.at(TokPos);
				if(sscanf(tok1.c_str(),"%1d%1d%f", &ind, &sgn, &AirTemp) == 3)
				{
	//				Set the temperature
					if(sgn==1)
					{ AirTemp *= (-1.0);}
					if(tok1.at(tok1.length()-1)=='/')
					{
						SetDryBulbTemp(AirTemp);
					}
					else
					{
						SetDryBulbTemp(AirTemp/10.0);
					}
				}
				continue;

			}

		}
	}

	delete [] string;
	return true;
}

void JJVV::Proc6Group(int TokPos, StringVect *Tokens)
{
	if(Tokens->size() >= TokPos+1)
	{
		std::string tok1 = Tokens->at(TokPos+1);
		if(tok1.at(0)=='1')// Total Water Depth
		{
			int twd = 0;
			int ind = 0;
			if(sscanf(tok1.c_str(),"%1d%4d",&ind,&twd)==2)
			{
				SetTotalWaterDepth(twd);
			}
			else
			{
				SetTotalWaterDepth(-1);
			}

		}
		else
		{
			// Check to see if this might be a call sign by checking for Alpha characters
				for(int k = 0; k < tok1.length(); k++)
				{
					if((tok1.at(k)>=65) && (tok1.at(k)<=90))
					{
						//This is a call sign
						SetWMO_ID((char *) tok1.c_str());
						return ;
					}
				}
		}


		// Try TokPos + 2  This should be current or the call sign or 99999 to indicate wmo_id follows
		if(Tokens->size() >= TokPos+2)
		{
			tok1 = Tokens->at(TokPos+2);
			if((tok1.find('/')<0)&&((tok1.at(0)>='1')&&(tok1.at(0)<='5')))
			{
				// Either a call sign or a current measurement
				// Call signs have an alpha character in most cases

				if((tok1.at(tok1.length()-1) == '=') &&(tok1.length() > 0))
				{
					// This is a Call Sign
					tok1.erase(tok1.length()-1,1);
					SetWMO_ID((char *) tok1.c_str());
					return ;
				}

				std::transform(tok1.begin(),tok1.end(),tok1.begin(), ::toupper);
				for(int k = 0; k < tok1.length(); k++)
				{
					if((tok1.at(k)>=65) && (tok1.at(k)<=90))
					{
						//This is a call sign
						SetWMO_ID((char *) tok1.c_str());
						return ;
					}
				}

				if(tok1.find("99999") == 0)
				{
				//	This is a buoy indicator. Next Element is the call sign
					if(Tokens->size() >= TokPos+3)
					{
						tok1 = Tokens->at(TokPos+3);
						if((tok1.at(tok1.length()-1) == '=') &&(tok1.length() > 0))
						{
							// This is a Call Sign
							tok1.erase(tok1.length()-1,1);
							SetWMO_ID((char *)tok1.c_str());
							return ;
						}
					}
				}

				// It's a current measurement

				int ind = -1;
				int curdir = -1;
				int curvel =-1;

				if(sscanf(tok1.c_str(),"%1d%2d%2d", &ind,&curdir,&curvel)==3)
				{
					SetCurrentDir(curdir);
					float currspd = (float) curvel/10;//*360.0/1852;
					SetCurrentSpeed(currspd);
					SetCurrMeasMeth(ind);
				}

				// if this is a current then the next token must be the call sign or "99999"
				if(Tokens->size() >= TokPos+3)
				{
					tok1 = Tokens->at(TokPos+3);

					std::transform(tok1.begin(),tok1.end(),tok1.begin(), ::toupper);
					for(int k = 0; k < tok1.length(); k++)
					{
						if((tok1.at(k)>=65) && (tok1.at(k)<=90))
						{
							//This is a call sign
							SetWMO_ID((char *) tok1.c_str());
							return ;
						}
					}

					if(tok1.find("99999") == 0)
					{
					//	This is a buoy indicator. Next Element is the call sign
						if(Tokens->size() >= TokPos+4)
						{
							tok1 = Tokens->at(TokPos+4);
							if((tok1.at(tok1.length()-1) == '=') &&(tok1.length() > 0))
							{
								// This is a Call Sign
								tok1.erase(tok1.length()-1,1);
								SetWMO_ID((char *) tok1.c_str());
								return ;
							}
						}
					}
				}


			}
			else if(tok1.find('/')>=0)
			{
				// messed up ob
				if(Tokens->size() >= TokPos+3)
				{
					tok1 = Tokens->at(TokPos+3);
					if(tok1.at(tok1.length()-1)=='=')
					{tok1.erase(tok1.length()-1,1);}
					SetWMO_ID((char *)tok1.c_str());
				}
			}
			else
			{
			// Current Missing! Must be Call Sign or 99999 group
				std::transform(tok1.begin(),tok1.end(),tok1.begin(), ::toupper);
				for(int k = 0; k < tok1.length(); k++)
				{
					if((tok1.at(k)>=65) && (tok1.at(k)<=90))
					{
						//This is a call sign
						SetWMO_ID((char *) tok1.c_str());
						return ;
					}
				}

				if(tok1.find("99999") == 0)
				{
				//	This is a buoy indicator. Next Element is the call sign
					if(Tokens->size() >= TokPos+2)
					{
						tok1 = Tokens->at(TokPos+2);
						if((tok1.at(tok1.length()-1) == '=') &&(tok1.length() > 0))
						{
							// This is a Call Sign
							tok1.erase(tok1.length()-1,1);
							SetWMO_ID((char *) tok1.c_str());
							return ;
						}
					}
				}
			}

		}
	}
}
	
int JJVV::Proc8Group(int start, char *k1, StringVect *tok)
{
	int insttype = 0;
	int rectype = 0;

	if(tok->at(start).at(4)=='7')
	{
		*k1 =  '7';
	}
	else if(tok->at(start).at(4)=='8')
	{
		*k1 =  '8';
	}

	if(tok->size() >= start+1)  // make sure that token exists in array
	{
		if(sscanf(tok->at(start+1).c_str(),"%3d%2d", &insttype, &rectype)==2)
		{
			SetInstType(insttype);
			SetRecorderType(rectype);
		}
	}
	int i = start;
	int Hunds = 0;
	int nines=0;
	SetDataType(3);
	for (i= start+2; i < tok->size();i++)
	{
		DepTemp  pair;
		pair.Depth = 0;
		pair.Temp = 0;
		std::string tok1 = tok->at(i);
		if(tok1.find("999")==0)
		{
			// change in hundreds of feet value
			if(sscanf(tok1.c_str(),"%3d%2d", &nines, &Hunds)==2)
			{
				Hunds *= 100;
				continue;
			}
		}
		
		if(tok1.find("66666")==0)
		{
			return i;
		}

		if(tok1.find("99999")==0)  //JJVV from Buoy
		{
			return i;
		}
		int d1 = 0;
// Check to see if this token has non digits.  If so it's the call sign
		for(int k = 0; k < tok1.length(); k++)
		{
			if((tok1.at(k)>=65) && (tok1.at(k)<=90))
			{
				return i;
			}
		}
		if(sscanf(tok->at(i).c_str(),"%2d%3f",&pair.Depth, &pair.Temp)==2)
		{
			pair.Depth += Hunds;
			pair.Temp /= 10;
			if(pair.Temp >50.0)
			{
				pair.Temp=(pair.Temp-50.0) * (-1);
			}
			Inflection.push_back(pair);
		}
	}

	return i;
}

unsigned long JJVV::ComputeMessCRC(bool *x)
{
	*x = true;
	if(GetDataType()!=1)
	{
		x = false;
		return 0;
	}
	SetUniqueTag((unsigned long) 0xFFFFFFFF);
	ComputeInflectionPoints();
	RetMess y = BuildBinMess(1);
	unsigned long mycrc = CalcCRC32(y.Mess,y.size);
//	delete [] y.Mess;
	return mycrc;
}


std::string JJVV::format(const char *fmt, ...) 
{ 
 
	// vsprintf	
   using std::string;
   using std::vector;

   string retStr("");

   if (NULL != fmt)
   {
      va_list marker = NULL; 

      // initialize variable arguments
      va_start(marker, fmt); 
      
      // Get formatted string length adding one for NULL
      size_t len = 100; //_vscprintf(fmt, marker) + 1;
               
      // Create a char vector to hold the formatted string.
	  vector<char> buffer(len, '\0');
	  while(1)
	  {
#ifdef _WIN32
		  int nWritten = _vsnprintf(&buffer[0], buffer.size(), fmt, marker);    
		  if (nWritten < 0)
		  {
			  buffer.resize(len+100);
			  len+=100;
			  continue;
		  }
		  else
		  {
			 retStr = &buffer[0];
			 break;
		  }
#endif
		  
#ifndef _WIN32
		  int nWritten = vsnprintf(&buffer[0], buffer.size(), fmt, marker);    
		  if (nWritten > buffer.size())
		  {
			  buffer.resize(nWritten);
			  continue;
		  }
		  else
		  {
			 retStr = &buffer[0];
			 break;
		  }
#endif
	  }
            
      // Reset variable arguments
      va_end(marker); 
   }

   return retStr; 
}

bool JJVV::DecodeElements(int start, int No_To_Decode, RetMess *InMess, int *BitPos)
{ 
	FM94Elem *y;
	FM94Value z;
	int size;
	int i;

	for ( i=start; i< start + No_To_Decode; i++)
	{
/*		if( i == 5)
		{
			printf("BitPos = %d\r\n", BitPos);
		}
*/
		y = (FM94Elem *) SEAS_Elem.at(i);

		// Just check to see if we may go outside message length
		// This theoretically should never happen
		size = y->GetMaxBits();
//		if((size+BitPos)/8 > InMess->size*8)
		if((size+*BitPos)/8 > InMess->size)
		{
			return false;
		}
		int j;
		for (j=0; j<sizeof(z.StrVal); j++)
		{
			z.StrVal[j] = (char) 255;
		}

		for (j=1; j<y->GetMaxBits()+1; j++)
		{
			if(CheckBit( *BitPos+j, InMess->Mess))
			{
				SetBit(j,1,z.StrVal);
			}
			else
			{
				SetBit(j,0,z.StrVal);
			}
		}

		int pp = strcmp(y->GetUnits(), "CCITT IA5");
		if(strcmp(y->GetUnits(), "CCITT IA5") != 0)
		{
			if(z.Integ!=-1)
			{

//				unsigned z1 = z.Integ;
				 // Swap the bytes to make integer appear as bit stream
				int noshifts = 32 - y->GetMaxBits();
				string xx = y->GetDesc();
				 char a = z.StrVal[0];
				 z.StrVal[0] = z.StrVal[3];
				 z.StrVal[3] = a;
				 a = z.StrVal[1];
				 z.StrVal[1] = z.StrVal[2];
				 z.StrVal[2] = a; 
				z.Integ = z.Integ >> noshifts;
				unsigned long mask = 0xffffffff;//(int) (pow((double) 2, (double) y->GetMaxBits() )-1.0);
				mask = mask >> noshifts;
				z.Integ=z.Integ & (unsigned) mask;				   

				y->SetValue((unsigned long) z.Integ);				
			}
		}
		else
		{
			y->SetValue(z.StrVal);
		}

		*BitPos += y->GetMaxBits();
	}
	return true;
}

bool JJVV::DecodeElements( RetMess *InMess, int *BitPos, FM94Elem *y)
{
	FM94Value z;
	int size;
//	int i;

		size = y->GetMaxBits();
//		if((size+BitPos)/8 > InMess->size*8)
		if((size+*BitPos)/8 > InMess->size)
		{
			return false;
		}
		int j;
		for (j=0; j<sizeof(z.StrVal); j++)
		{
			z.StrVal[j] = (char) 255;
		}

		for (j=1; j<y->GetMaxBits()+1; j++)
		{
			if(CheckBit( *BitPos+j, InMess->Mess))
			{
				SetBit(j,1,z.StrVal);
			}
			else
			{
				SetBit(j,0,z.StrVal);
			}
		}

		int pp = strcmp(y->GetUnits(), "CCITT IA5");
		if(strcmp(y->GetUnits(), "CCITT IA5") != 0)
		{
			if(z.Integ!=-1)
			{

//				unsigned z1 = z.Integ;
				 // Swap the bytes to make integer appear as bit stream
				int noshifts = 32 - y->GetMaxBits();
				 char a = z.StrVal[0];
				 z.StrVal[0] = z.StrVal[3];
				 z.StrVal[3] = a;
				 a = z.StrVal[1];
				 z.StrVal[1] = z.StrVal[2];
				 z.StrVal[2] = a; 
				z.Integ = z.Integ >> noshifts;
				unsigned long mask = 0xffffffff;//(int) (pow((double) 2, (double) y->GetMaxBits() )-1.0);
				mask = mask >> noshifts;
				z.Integ=z.Integ & mask;

				y->SetValue((unsigned long) z.Integ);				
			}
		}
		else
		{
			y->SetValue(z.StrVal);
		}

		*BitPos += y->GetMaxBits();
	
	return true;
}

std::string JJVV::NODCform( unsigned long *CRC)
{

	string Line1="";
	Line1 += NODCformMETA_1 (&*CRC);
	Line1 += NODCformProfile();
	return Line1;
}

string JJVV::NODCformMETA_1 (unsigned long *CRC)
{	
//	CStdioFile MyfileO;
	string Line, Ship, WMOID;
	char line[81];
	Profiler Inst;
	string Line1, Line2;

	{
		int SEASver = GetSEASVersion();
		if(SEASver == -1){SEASver = 612;}
		int RecType = GetRecorderType();
		CodeTable Recorder = GetRecorderInfo(RecType);
		int insttype = GetInstType();
		Inst = GetInstInfo(insttype);

		Ship = GetShipName();
		if(Ship.empty())
		{
			Ship = "Not Available";
		}
		WMOID = GetWMO_ID();
		tm OBtime = GetObTime();
		double lat = GetLat();
		double lon = GetLon();
//		double n, f;
		char latq = 'N';
		char lonq = 'E';
		if(lat < 0.0){ latq = 'S';}
		if(lon < 0.0){ lonq = 'W';}
		int LloydsNo = GetLloyds();
		int ob_day=OBtime.tm_mday;
		int i;
		int ProbeSN = -2;

		// Retrieve the Probe Serial Number from the Vector rather than the Variable.
		// The Variable on the SEAS_Elem vector contains the correct value for derived object
		for ( i =0; i< SEAS_Elem.size();i++)
		{
			FM94Elem *Val;
			Val = (FM94Elem *)SEAS_Elem.at(i);
			string a = Val->GetDesc();
			size_t kkk = a.find("PROBE SERIAL NUMBER");
			if(a.find("PROBE SERIAL NUMBER")!= (size_t) -1)
			{
				ProbeSN = SEAS_Elem.at(i)->GetValue().Integ;
				break;
			}
//			printf("%s\n",a.c_str());
		}
		Line = format(" SEAS Version: %5.2f\r\n Ship Name: %s\r\n Call Sign: %s\r\n Lloyds Number: %8d\r\n Date/Time(dd/mm/yyyy): %02d/%02d/%04d %02d:%02d GMT\r\n Latitude(ddd.ddd): %07.3f %c\r\n Longitude(ddd.ddd): %07.3f %c\r\n Probe Type: %s\r\n Probe Code: %3d\r\n Probe Serial No: %07d\r\n Recorder Type: %s\r\n Recorder Code: %2d\r\n",
			((float) SEASver)/100.0, Ship.c_str(),WMOID.c_str(), LloydsNo, OBtime.tm_mday, OBtime.tm_mon+1, OBtime.tm_year+1900, OBtime.tm_hour, OBtime.tm_min,(fabs(lat)), latq, (fabs(lon)), lonq, Inst.Instrument, insttype, ProbeSN, Recorder.Definition, RecType);
#ifndef _WIN32
		Line.append("\n");
#endif
		int LineLen = Line.size();
		
//		cout << (int) Line.at(LineLen-1) << endl;
		
		Line1+=Line;
		unsigned long seasid = GetUniqueTag();
		
		int bd = GetTotalWaterDepth();
		if(bd == -1){bd = 9999;}
		float WS = GetWindSpeed();
		int WD = GetWindDir();
		int WiInst = GetTypeWindInst();
		float CS = GetCurrentSpeed();
//		printf ("Current Speed = %5f.2\r\n", CS);
		int CD = GetCurrentDir();
		int CMM = GetCurrMeasMeth();
		float DBT = GetDryBulbTemp();
		
//		cout << "DBT=" << DBT << endl;

//		if(DBT!=-9999.0)
		{
			Line = format(" Dry Bulb Temp: %5.1f\r\n",DBT);
			Line1 += Line;
		}
			
//		if(WiInst!=-1)
		{
			string x = GetTypeWindInstInfo(WiInst).Definition;
//			cout << X << endl;
			if(x.length()==0)
			{
				x="Missing";
			}
			Line = format(" Wind Instr Type: %s\r\n",x.c_str());
			Line1 += Line;
		}
			
//		if(WS!=-1.0)
		{
			Line = format(" Wind Speed: %5.1f\r\n",WS);
			Line1 += Line;
		}
		
//		if(WD!=-1)
		{
			Line = format(" Wind Dir: %5d\r\n",WD);
			Line1 += Line;
		}
		
//		if(CMM!=-1)
		{
			string x = GetCurrMeasMethInfo(CMM).Definition;
			if(x.length() ==0)
			{
				x = "Missing";
			}
			Line = format(" Current Measurement Method: %s\r\n",x.c_str());
			Line1 += Line;
		}
		
//		if(CS!=-1.0)
		{
			Line = format(" Current Speed: %5.2f\r\n",CS);
			Line1 += Line;
		}
		
//		if(CD!=-1)
		{
			Line = format(" Current Dir: %5d\r\n",CD);
			Line1 += Line;
		}
		
				

		if(*CRC==0xFFFFFFFF)
		{
			Line=format(" Bottom Depth: %4d M\r\n SEAS ID: %8X\r\n", bd, seasid);
		}
		else
		{
			Line=format(" Bottom Depth: %4d M\r\n GTS CRC: %8X\r\n SEAS ID: %8X\r\n", bd, *CRC, seasid);
		}
		Line1+=Line;
	}
	return Line1;
}

string JJVV::NODCformProfile()
{
	string Line, Line1,  Line2;
	
/*#ifdef _WIN32
	int i;
#endif*/
	int i;

	int thisdata = GetDataType();
	if(thisdata == 3)
	{

		bool twometer = true;
		// Check to see if profile's points are at 2 meter intervals
		// This means that this profile was decoded from JJVV message rather that Raw Binary
		// and we will handle these as if they are inflection points at two meter intervals.
		// This is because we require a depth/temperature pair just like inflection points
		for (i=0; i < GetNumInflectPts();i++)
		{
			DepTemp point = GetInfPointAt(i);
			if(point.Depth!= (i+1)*2)
			{
				twometer = false;
				break;
			}
		}

		if(!twometer)
		{
			Line=format("\r\n\r\nINFPTS:%3d\r\n", GetNumInflectPts());
		}
		else
		{
			Line=format("\r\n\r\nTWOMETER:%5d\r\n", GetNumInflectPts());
		}
		Line1+=Line;
		Line2 = "";
/*#ifndef _WIN32
		int i;
#endif*/
		
		for(i=0;i<GetNumInflectPts(); i++)
		{
			DepTemp point = GetInfPointAt(i);
			Line=format("%5d%5d", point.Depth*10, (int) (point.Temp * 100));
			Line2+=Line;
			if((i>0)&&((i+1)%8==0))
			{
				Line2+="\r\n";
			}
		}
		if((i+1)%8 != 0)
		{
			Line2+="\r\n";
		}
		Line1+=Line2;

	}
	else if(thisdata == 2)
	{
		// This was transmitted from the Ship as two meter values

		Line=format("\r\n\r\nTWOMETER:%5d\r\n", GetLastOMDepth()/2);
		Line1+=Line;
		Line2 = "";
/*#ifndef _WIN32
		int i;
#endif*/
		for( i=2;i<GetLastOMDepth(); i+=2)
		{
			float temp = GetOneMeterValueAt(i);
			Line=format("%5d%5d", i*10, (int) (temp * 100));
			Line2+=Line;
			if((i>0)&&((i/2)%8==0))
			{
				Line2+="\r\n";
			}
		}
		if((i/2)%8 != 0)
		{
			Line2+="\r\n";
		}
		Line1 += Line2;
	}
	else if (thisdata==1)
	{

		// Check to see if Inflection points computed for this profile
/*#ifndef _WIN32
		int i;
#endif*/
		
		if(GetNumInflectPts() > 0)
		{
			Line=format("\r\n\r\nINFPTS:%3d\r\n", GetNumInflectPts());
			Line1+=Line;
			Line2 = "";
			for(i=0;i<GetNumInflectPts(); i++)
			{
				DepTemp point = GetInfPointAt(i);
				Line=format("%5d%5d", point.Depth*10, (int) (point.Temp * 100));
				Line2+=Line;
				if((i>0)&&((i+1)%8==0))
				{
					Line2+="\r\n";
				}
			}
			if((i+1)%8 != 0)
			{
				Line2+="\r\n";
			}
			Line1 += Line2;

		}
// Check to See if one meter values are computed in this profile
		int Lastdepth;
		if(GetTailDepth()>0)
		{
			Lastdepth = GetTailDepth();
		}
		else
		{
			Lastdepth = GetLastOMDepth();
		}
		if(GetLastOMDepth() > 0)
		{
			Line=format("\r\n\r\nTWOMETER:%5d\r\n", Lastdepth/2);
			Line1 += Line;
			Line2 = "";
			for(i=2;i<=Lastdepth; i+=2)
			{
				float temp = GetOneMeterValueAt(i);
				Line=format("%5d%5d", i*10, (int) (temp * 100));
				Line2+=Line;
				if((i>0)&&((i/2)%8==0))
				{
					Line2+="\r\n";
				}
			}
			if((i/2)%8 != 0)
			{
				Line2+="\r\n";
			}
			Line1 += Line2;
		}

		Line2 = "";
		for(i=0;i<GetNoOfPoints(); i++)
		{
/*				if(Profile->GetDepthAtPos(i) >Lastdepth)
			{
				break;
			}*/
			float temp = GetTempAtPos(i);
#ifndef SCRIPPS
			Line=format("%4d", (int) (temp * 100));
#endif
#ifdef SCRIPPS
			Line=format("%5d", (int) (temp * 1000));
#endif

			Line2+=Line;
			if((i>0)&&((i+1)%20==0))
			{
				Line2+="\r\n";
			}
		}
		if((i+1)%20 != 0)
		{
			Line2+="\r\n";
		}
		Line=format("\r\n\r\nXBT:%5d\r\n", i);
		Line1 += Line;
		Line1 += Line2;
		}
	return Line1;
}

bool JJVV::CalcJJVVCrc(string *mess, unsigned long *thiscrc)
{
//	int start = mess.Find("JJVV");
//	int end = mess.Find("=")-start;
//	CString Value= mess.Mid(start,end);
	vector <string> Tokens;
	unsigned long MessCrc;

	char *T_string;
	char *token;

	string Sub = "";
//	string Sub1 = mess->c_str();
//	string Sub1 = mess->c_str();

	T_string = new char[mess->length()+1];
	strcpy(T_string,mess->c_str());
	token = strtok(T_string," \t\n\r=");  // break the string into tokens
	if(token != NULL)
	{
		Tokens.push_back(string(token));
	}

	while(token != NULL)
	{
		token = strtok(NULL," \t\n\r=");
		if(token == NULL)
		{break;}
		Tokens.push_back(string(token));
	}


	for (int i=0; i< Tokens.size(); i++)
	{
		Sub += string(" ")+Tokens.at(i).c_str();			// put the string back together with leading space before each token
	}
	Sub += "=";               // put an equals sign at the end of the string



	int jjvv = Sub.find(" 8888");  // find the 8888 group

	if(jjvv==string::npos)
	{return false ;}// false;}


	
	Sub = Sub.substr(jjvv+6);

	
	int equals = Sub.find("=");

	string CRCString = Sub.substr(0,equals+1);


	int len = CRCString.length();
//	const char *mess1=CRCString.c_str();
	char *mess1=(char *)CRCString.c_str();
//	strcpy(mess1,CRCString.c_str());
	
	MessCrc = CalcCRC32(mess1,len);

	delete [] T_string;
//	delete [] *mess1;
	*thiscrc = MessCrc;
	return true;
	
}
