#include <jjvv_1.h>
#include <jjvv_2.h>
#include <jjvv_3.h>
#include <math.h>


using namespace std;

/* PIC 09/20/11 modified to override DecodeElements and DecodeBinMess in JJVV. This allows
	a JJVV_1 type message to be decoded by a JJVV_2 object. If the UniqueTag is recomputed
	after a JJVV_1 has been decoded, the UniqueTag (CRC) will not equal the one embedded in the 
	JJVV_1 binary message.  This is due to the additional bits added in the JJVV_2 message
*/

// PIC 11/05/2014 Derived from JJVV_2 to add additional elements.


JJVV_3::JJVV_3()
{
	DecodeType1 = false;
	SetMessType(3);
//#ifndef _WIN32
	int i;
//#endif

	RiderName = "";
	RiderEmail = "";
	RiderInst = "";
	RiderPhoneNo = "";

	No_RiderBlocks.SetValue(0);
	No_RiderEmailBlocks.SetValue(0);
	No_RiderPhoneBlocks.SetValue(0);
	No_RiderInstBlocks.SetValue(0);



	SEAS_Elem.pop_back();
	SEAS_Elem.pop_back();
	SEAS_Elem.push_back(&AgencyOwner);
	SEAS_Elem.push_back(&XBTLauncherType);
	SEAS_Elem.push_back(&XBTRecorderSerial);
	SEAS_Elem.push_back(&XBT_Rec_Manuf_Year);
	SEAS_Elem.push_back(&XBT_Rec_Manuf_Month);
	SEAS_Elem.push_back(&XBT_Rec_Manuf_Day);
	SEAS_Elem.push_back(&XBT_Probe_Manuf_Year);
	SEAS_Elem.push_back(&XBT_Probe_Manuf_Month);
	SEAS_Elem.push_back(&XBT_Probe_Manuf_Day);
	SEAS_Elem.push_back(&No_RiderBlocks);
	SEAS_Elem.push_back(&No_RiderInstBlocks);
	SEAS_Elem.push_back(&No_RiderEmailBlocks);
	SEAS_Elem.push_back(&No_RiderPhoneBlocks);
	SEAS_Elem.push_back(&NoRepFields);
	SEAS_Elem.push_back(&TimesReplicated);
	ComputeMessSize();


	for (  i =0; i< SEAS_Elem.size();i++)
	{
		FM94Elem *Val;

		Val = (FM94Elem *)SEAS_Elem.at(i);
		string a = Val->GetDesc();
//		printf("%s\n",a.c_str());
	}
//	printf("\n");

};


JJVV_3::~JJVV_3()
{};

void JJVV_3::SetRiderName(char * name)
{
	std::string x = name;
	int NB = x.length()*8;
	FXY205030A comment;

	if(NB%comment.GetMaxBits()==0)
	{
		NB = NB/comment.GetMaxBits();
	}
	else
	{
		NB = NB/comment.GetMaxBits()+1;
	}
	RiderName = name;
	No_RiderBlocks.SetValue(NB);
};
/*	FXY31001B 
	FXY31001B 
	FXY31001B No_RiderPhoneBlocks;
	FXY31001B ;*/

std::string JJVV_3::GetRiderName()
{
	return RiderName;
};

void JJVV_3::SetRiderEmail (char * name) //"Caridad.I.Gonzalez@noaa.gov";
{
	std::string x = name;
	int NB = x.length()*8;
	FXY205030A comment;

	if(NB%comment.GetMaxBits()==0)
	{
		NB = NB/comment.GetMaxBits();
	}
	else
	{
		NB = NB/comment.GetMaxBits()+1;
	}

	RiderEmail = name;
	No_RiderEmailBlocks.SetValue(NB);
};

std::string JJVV_3::GetRiderEmail ()
{
	return RiderEmail;
};

void JJVV_3::SetRiderInst(char * name) // = "AOML PHoD";
{
	std::string x = name;
	int NB = x.length()*8;
	FXY205030A comment;

	if(NB%comment.GetMaxBits()==0)
	{
		NB = NB/comment.GetMaxBits();
	}
	else
	{
		NB = NB/comment.GetMaxBits()+1;
	}
	RiderInst = name;
	No_RiderInstBlocks.SetValue(NB);
};

std::string JJVV_3::GetRiderInst()
{
	return RiderInst;
};

void JJVV_3::SetRiderPhoneNo(char * name)
{
	std::string x = name;
	int NB = x.length()*8;
	FXY205030A comment;

	if(NB%comment.GetMaxBits()==0)
	{
		NB = NB/comment.GetMaxBits();
	}
	else
	{
		NB = NB/comment.GetMaxBits()+1;
	}
	RiderPhoneNo = name;
	No_RiderPhoneBlocks.SetValue(NB);

};

std::string JJVV_3::GetRiderPhoneNo()
{
	return RiderPhoneNo;
};

bool JJVV_3::SetAgencyOwner(int code)
{
	if(AgencyOwner.ValidValue(code))
	{
		AgencyOwner.SetValue(code);
		return true;
	}
	else
	{
		return false;
	}
};




AgencyTable JJVV_3::GetAgencyOwner(int Elem)
{
	return AgencyOwner.GetTableElem(Elem);
};


bool JJVV_3::SetXBTLauncherType(int code)
{
	if(XBTLauncherType.ValidValue(code))
	{
		XBTLauncherType.SetValue(code);
		return true;
	}
	return false;
};

CodeTable JJVV_3::GetXBTLauncherType()
{
	FM94Value x = XBTLauncherType.GetValue();
	return XBTLauncherType.GetTableElem(x.Integ);
};

void JJVV_3::SetRecorderSerialNo(char * SerialNo)
{
	XBTRecorderSerial.SetValue(SerialNo);
};

std::string JJVV_3::GetRecorderSerialNo()
{
	string x = XBTRecorderSerial.GetBufrVal();
	if(XBTRecorderSerial.GetValue().Integ == 0xFFFFFFFF)
	{
		x="Missing";
	}
	return x;
};
std::string JJVV_3::NODCform( unsigned long *CRC)
{

	string Line1="";
	Line1 += NODCformMETA_1 (&*CRC);
	Line1 += NODCformMETA_2 ();
	Line1 += NODCformMETA_3 ();
	Line1 += NODCformProfile();
	return Line1;
}
std::string JJVV_3::NODCformMETA_3()
{
	string Line, Line1;
	Line1="";

	CodeTable A = GetXBTLauncherType();
	Line = format(" XBT Launcher Type: %s\r\n", A.Definition);
	Line1 += Line;

	Line = format(" XBT Recorder Serial Number: %s\r\n", GetRecorderSerialNo().c_str());
	Line1 += Line;

	tm a = GetXBTRecorderManufDate();
	if (a.tm_year==-1)
	{
		Line = " XBT Recorder Manufacture Date: 01/01/1970\r\n";
	}
	else
	{
		Line = format(" XBT Recorder Manufacture Date: %0.2d/%0.2d/%0.4d\r\n",a.tm_mon+1, a.tm_mday, a.tm_year+1900);
	}
	Line1 += Line;

	a = GetXBTManufDate();
	if (a.tm_year==-1)
	{
		Line = " Probe Manufacture Date: 01/01/1970\r\n";
	}
	else
	{
		Line = format(" Probe Manufacture Date: %0.2d/%0.2d/%0.4d\r\n",a.tm_mon+1, a.tm_mday, a.tm_year+1900);
	}
	Line1 += Line;

	FM94Value x = AgencyOwner.GetValue();
	AgencyTable x1 = AgencyOwner.GetTableElem(x.Integ);
	Line = format(" Agency in charge of Operation: %s\r\n", x1.Definition);
	Line1 += Line;
	Line = format(" Ship Rider: %s\r\n", GetRiderName().c_str());
	Line1 += Line;
	Line = format(" Ship Rider Institution: %s\r\n", GetRiderInst().c_str());
	Line1 += Line;
	Line = format(" Ship Rider Email: %s\r\n", GetRiderEmail().c_str());
	Line1 += Line;
	Line = format(" Ship Rider Telephone Number: %s\r\n", GetRiderPhoneNo().c_str());
	Line1 += Line;
/*	Line = format(" Sequence Number: %5d\r\n",GetSeqNo());
	Line1 += Line;
	Line = format(" Transect Number: %4d\r\n", GetTransectNo());
	Line1 += Line;
	Line = format(" Launch Height (Meters): %5.2f\r\n", GetLaunchHeight());
	Line1 += Line;
	string soopline = GetSOOPLine();
	Line = format(" SOOP Line: %s\r\n",soopline.c_str());
	Line1 += Line;
	*/
	return Line1;		
};


void JJVV_3::SetXBTRecorderManufDate(tm ManufDate)
{
	XBT_Rec_Manuf_Year.SetValue(ManufDate.tm_year+1900);
	XBT_Rec_Manuf_Month.SetValue(ManufDate.tm_mon+1);
	XBT_Rec_Manuf_Day.SetValue(ManufDate.tm_mday);
};

tm JJVV_3::GetXBTRecorderManufDate()
{
	tm st;
//
	if(XBT_Rec_Manuf_Year.IsValid())
	{
		st.tm_year=XBT_Rec_Manuf_Year.GetValue().Integ-1900;
	}
	else
	{ st.tm_year = -1;}
//  
	if(XBT_Rec_Manuf_Month.IsValid())
	{
		st.tm_mon=XBT_Rec_Manuf_Month.GetValue().Integ-1;
	}
	else
	{ st.tm_mon = -1;}
//
	if(XBT_Rec_Manuf_Day.IsValid())
	{
		st.tm_mday= XBT_Rec_Manuf_Day.GetValue().Integ;
	}
	else
	{ st.tm_mday = -1;}

//	

	st.tm_hour = -1;
	st.tm_min = -1;
	st.tm_wday = -1;
	st.tm_yday= -1;
	st.tm_sec = 0;
	st.tm_isdst = -1;
	return st;
};

void JJVV_3::SetXBTManufDate(tm ManufDate)
{
	XBT_Probe_Manuf_Year.SetValue(ManufDate.tm_year+1900);
	XBT_Probe_Manuf_Month.SetValue(ManufDate.tm_mon+1);
	XBT_Probe_Manuf_Day.SetValue(ManufDate.tm_mday);
};

tm JJVV_3::GetXBTManufDate()
{
	tm st;
//
	if(XBT_Probe_Manuf_Year.IsValid())
	{
		st.tm_year=XBT_Probe_Manuf_Year.GetValue().Integ-1900;
	}
	else
	{ st.tm_year = -1;}
//  
	if(XBT_Probe_Manuf_Month.IsValid())
	{
		st.tm_mon=XBT_Probe_Manuf_Month.GetValue().Integ-1;
	}
	else
	{ st.tm_mon = -1;}
//
	if(XBT_Probe_Manuf_Day.IsValid())
	{
		st.tm_mday= XBT_Probe_Manuf_Day.GetValue().Integ;
	}
	else
	{ st.tm_mday = -1;}

//	

	st.tm_hour = -1;
	st.tm_min = -1;
	st.tm_wday = -1;
	st.tm_yday= -1;
	st.tm_sec = 0;
	st.tm_isdst = -1;
	return st;
};
RetMess JJVV_3::BuildBinMess(int type)
{

// push the string element valuse onto a vector
	std::vector <std::string> vect;

	vect.clear();
	vect.push_back(RiderName);
	vect.push_back(RiderEmail);
	vect.push_back(RiderInst);
	vect.push_back(RiderPhoneNo);

// compute the number of comment blocks to be added to the end of the binary message.
	ComputeNoCommentBlocks();
	std::vector <FXY205030A*> Comment_Fields;

	// build the basic JJVV binary message
	RetMess x = JJVV::BuildBinMess(type);

	int bitpos = SetBitPos;

	int StartElem = SEAS_Elem.size();

	// Add the text blocks for the Rider Information

	FXY205030A* Comm_Block = new FXY205030A;
	int maxbits = Comm_Block->GetMaxBits();

	int i;
	int NB;

	for(i=0;i<vect.size();i++)
	{
		NB = vect.at(i).length()*8;

		if(NB%Comm_Block->GetMaxBits()==0)
		{
			NB = NB/Comm_Block->GetMaxBits();
		}
		else
		{
			NB = NB/Comm_Block->GetMaxBits()+1;
		}

		int j;
		for(j=0; j<NB; j++)
		{
			Comm_Block = new FXY205030A;
			string pc = vect.at(i).substr(j*5,5);
			Comm_Block->SetValue((char *) pc.c_str());
//			Comm_Block->SetValue((char *)vect.at(i).substr(j*5,5).c_str());
			Comment_Fields.push_back(Comm_Block);
		}
	}

// compute the new message size by using the last bit position and the new number of bits added
	// to the message
	int MessSize = (bitpos + maxbits*NoRiderCommentBlocks)/8;
	if((bitpos + maxbits*NoRiderCommentBlocks)%8 !=0)
	{
		MessSize++;
	}

// copy the original message to newly allocated space in a new RetMess variable

	RetMess ret;
	ret.size=MessSize;
	ret.Mess=new char[MessSize];
	memset(ret.Mess,0xFF,ret.size);
	memcpy(ret.Mess,x.Mess,x.size);

// free the memory allocated to x.Mess
//	delete [] x.Mess;

//  Set the remaining bits in the message
	char *z;
	int NumBits;
	FM94Elem* y;
	for ( i=0; i< Comment_Fields.size(); i++)
	{
		y = (FM94Elem *) Comment_Fields.at(i);
//			z =	y->GetBufrVal();
		z =	y->GetBufrVal();
		NumBits = y->GetMaxBits();

	// Check if a particular bit is set in the value

		for(int j = 1;j < NumBits+1; j++)
		{
			if(CheckBit(j,z))
			{
				SetBit(bitpos+j,1,ret.Mess);
			}
			else
			{
				SetBit(bitpos+j,0,ret.Mess);
			}

		}
		bitpos += NumBits;
	}

	return ret;
	// do some Stuff
};

void JJVV_3::ComputeNoCommentBlocks()
{
	int x=0;
	std::vector <FXY31001B> vect;

	vect.clear();
	vect.push_back(No_RiderBlocks);
	vect.push_back(No_RiderEmailBlocks);
	vect.push_back(No_RiderPhoneBlocks);
	vect.push_back(No_RiderInstBlocks);
	int i;
	int nob;
	for (i=0; i<vect.size();i++)
	{
		nob = vect.at(i).GetValue().Integ;
		if(nob == -1)
		{
			x+=0;
		}
		else
		{
			x+=nob;
		}

	}
	NoRiderCommentBlocks = x;

/*	FXY31001B No_RiderBlocks;
FXY31001B No_RiderEmailBlocks;
FXY31001B No_RiderPhoneBlocks;
FXY31001B No_RiderInstBlocks;
*/

};
bool JJVV_3::DecodeBinMess(RetMess* data)
{
	JJVV::DecodeBinMess(data);

	int SEASBlocks = SEAS_Elem.size();
	int SizeNow=ComputeMessSize();
	ComputeNoCommentBlocks();

	int i;

// Push the number com comment blocks onto the SEAS_Elem vector so that they can be 
// decoded by DecodeElements() method

	for(i=0;i<NoRiderCommentBlocks;i++)
	{
		FXY205030A* Comm_Block = new FXY205030A;
		SEAS_Elem.push_back(Comm_Block);
	}

	DecodeElements( SEASBlocks, NoRiderCommentBlocks, data, &BitPos);

	std::vector <FXY31001B> vect;
	std::vector <std::string *> vect1;

	vect.clear();
	vect.push_back(No_RiderBlocks);
	vect.push_back(No_RiderEmailBlocks);
	vect.push_back(No_RiderInstBlocks);
	vect.push_back(No_RiderPhoneBlocks);

	vect1.clear();
	vect1.push_back(&RiderName);
	vect1.push_back(&RiderEmail);
	vect1.push_back(&RiderInst);
	vect1.push_back(&RiderPhoneNo);

// build the strings for the respective comment fields

	int start = SEASBlocks;
	for(i=0;i<vect.size();i++)
	{
		int j;

		int nob = vect.at(i).GetValue().Integ;
		std::string x = "";
		for(j=0;j<nob;j++)
		{
			x += SEAS_Elem.at(start)->GetBufrVal();
//			x+=val.StrVal;
			start++;
		}
		*vect1.at(i) =x;


	}

// Remove the comment blocks from the SEAS_Elem Vector
	for(i=0;i<NoRiderCommentBlocks;i++)
	{
		SEAS_Elem.pop_back();
	}

	return true;
};
/*void JJVV_3::DecodeRiderBlocks(int bitpos)
{
	std::vector <FXY205030A*> Comment_Fields;

	ComputeNoCommentBlocks();

	int SEASBlocks = SEAS_Elem.size();
	int i;

	for(i=0;i<NoRiderCommentBlocks;i++)
	{
		FXY205030A* Comm_Block = new FXY205030A;
		SEAS_Elem.push_back(Comm_Block);
	}


};
*/

unsigned long JJVV_3::ComputeMessCRC(bool *x)
{
	// Method required here because JJVV::ComputeMessCRC() will not builsd a JJVV_3 Binary Message
	// This routin will invoke JJVV_3::ComputeMessCRC()
	
	*x = true;
	if(GetDataType()!=1)
	{
		x = false;
		return 0;
	}
	SetUniqueTag((unsigned long) 0xFFFFFFFF);
	ComputeInflectionPoints();
	RetMess y = BuildBinMess(1);
	unsigned long mycrc = CalcCRC32(y.Mess,y.size);
//	delete [] y.Mess;
	return mycrc;
}
