#include <FM94Elem.h>
#include <SEASOB_1.h>
#include <math.h>
#include <time.h>
#include <malloc.h>
#include <memory.h>

// PIC 11/05/2014

SEASOB::SEASOB()
{
// SingleCoeff X;
	SEASOBSize =0;
	SEAS_Elem.push_back(&WMO_ID);
	SEAS_Elem.push_back(&Old_Mess_Type);  //Rogers first SEAS messages.  ALL 1's if > SEAS2K
	SEAS_Elem.push_back(&New_Mess_Type);  
	SEAS_Elem.push_back(&Lat);
	SEAS_Elem.push_back(&Lon);
	SEAS_Elem.push_back(&Year);
	SEAS_Elem.push_back(&Month);
	SEAS_Elem.push_back(&Day);
	SEAS_Elem.push_back(&Hour);
	SEAS_Elem.push_back(&Minute);

//	FXY22067 FF = (FXY22067) SEAS_Elem.at(5);
	FXY22067 *K = (FXY22067 *) SEAS_Elem.at(5);
//	FXY22067 *K = (FXY22067 *) (SEAS_Elem.begin());
//	K->SetValue(2);

	No_SEASOBS_Elements = SEAS_Elem.size();

	SEASOBSize = ComputeMessSize();
/*	int k=0;
	FM94Elem *Val;
	for (int i=0;i<SEAS_Elem.size();i++)
	{
		Val = (FM94Elem *) SEAS_Elem.at(i);
		SEASOBSize+=Val->GetMaxBits();
	}

*/
//172 bits
}

SEASOB::~SEASOB()
{
	
}

int SEASOB::ComputeMessSize()
{
	// compute the length in bits of the message as it now stands
	FM94Elem *Val;

	OBGenSize = 0;
	for (int i=0;i<SEAS_Elem.size();i++)
	{
	Val = (FM94Elem *)SEAS_Elem.at(i);
	OBGenSize+=Val->GetMaxBits();
	}
	MessSize = OBGenSize;
	return OBGenSize;
}

double SEASOB::GetLat()
{
	 if(Lat.IsValid() == false)//JB
	  return -9999.0;
	if(Lat.GetValue().Integ == -1)
	{
		return -9999.0;
	}
	else
	{
		return (((double) Lat.GetValue().Integ + Lat.GetOffset())/pow(10.0,Lat.GetScale()));
	}
}

/*********************/


double SEASOB::GetLon()
{
	 if(Lon.IsValid() == false)//JB
	  return -9999.0;
	if(Lon.GetValue().Integ == -1)
	{
		return -9999.0;
	}
	else
	{
		return   (((double) Lon.GetValue().Integ + Lon.GetOffset())/pow(10.0,Lon.GetScale()));
	}
}


void SEASOB::SetWMO_ID(char *ID)
{
	WMO_ID.SetValue(ID);
}

void SEASOB::SetMessType(int type)
{
	New_Mess_Type.SetValue(type);
}

int SEASOB::GetMessType()
{
	
	FM94Value type=New_Mess_Type.GetValue();
	return type.Integ;
}



tm SEASOB::GetObTime()
{
	tm st;
//
	if(Year.IsValid())
	{
		st.tm_year=Year.GetValue().Integ-1900;
	}
	else
	{ st.tm_year = -1;}
//  
	if(Month.IsValid())
	{
		st.tm_mon=Month.GetValue().Integ-1;
	}
	else
	{ st.tm_mon = -1;}
//
	if(Day.IsValid())
	{
		st.tm_mday= Day.GetValue().Integ;
	}
	else
	{ st.tm_mday = -1;}

//	
	if(Hour.IsValid())
	{
		st.tm_hour=Hour.GetValue().Integ;
	}
	else
	{st.tm_hour = -1;}
//
	if(Minute.IsValid())
	{
		st.tm_min=Minute.GetValue().Integ;
	}
	else
	{ st.tm_min = -1;}

	st.tm_wday = -1;
	st.tm_yday= -1;
	st.tm_sec = 0;
	st.tm_isdst = -1;
	return st;
}

int SEASOB::GetQuadrant()
{
	int Quad;
	double lat;
	double lon;
	lat = GetLat();
	lon = GetLon();
	if((lat==-9999.0)|| (lon==-9999.0))
	{
		return -1;
	}

	if((lat>=0) && (lon<=0))
	{
		Quad = 7;
	}
	else if((lat>=0) && (lon>0))
	{
		Quad = 1;
	}
	else if((lat<0) && (lon>=0))
	{
		Quad = 3;
	}
	else if((lat<0) && (lon<=0))
	{
		Quad = 5;
	}
	return Quad;
}

std::string SEASOB::GetWMO_ID()
{
	std::string x =  WMO_ID.GetValue().StrVal;
	if(x.at(0) == (char)255)
	{
		x = "";
	}
	return x;

}


void SEASOB::SetLat(double L )
{
	int s = Lat.GetScale();
	int off = Lat.GetOffset();
	int x = int(pow(10,(double)s) * (double)L - (double)off);
	Lat.SetValue(x);
}


//		 SetLon(double);
void SEASOB::SetLon(double L )
{
	int s = Lon.GetScale();
	int off = Lon.GetOffset();
	int x = int(pow(10,(double)s) * (double)L - (double)off);
	Lon.SetValue(x);
}


void SEASOB::SetObtime(tm obtime)
{
	Year.SetValue(obtime.tm_year+1900);
	Month.SetValue(obtime.tm_mon+1);
	Day.SetValue(obtime.tm_mday);
	Hour.SetValue(obtime.tm_hour);
	Minute.SetValue(obtime.tm_min);

}

unsigned long SEASOB::reflect (unsigned long crc, int bitnum) {

// reflects the lower 'bitnum' bits of 'crc'

	unsigned long i, j=1, crcout=0;

	for (i=(unsigned long)1<<(bitnum-1); i; i>>=1) {
		if (crc & i) crcout|=j;
		j<<= 1;
	}
	return (crcout);
}

void SEASOB::generate_crc_table() {

// make CRC lookup table used by table algorithms

	int i, j;
	unsigned long bit, crc;

	for (i=0; i<256; i++) {

		crc=(unsigned long)i;
		if (refin) crc=reflect(crc, 8);
		crc<<= order-8;

		for (j=0; j<8; j++) {

			bit = crc & crchighbit;
			crc<<= 1;
			if (bit) crc^= polynom;
		}			

		if (refin) crc = reflect(crc, order);
		crc&= crcmask;
		crctab[i]= crc;
	}
}
		
unsigned long SEASOB::crctablefast (unsigned char* p, unsigned long len) {

// fast lookup table algorithm without augmented zero bytes, e.g. used in pkzip.
// only usable with polynom orders of 8, 16, 24 or 32.

	unsigned long crc = crcinit_direct;

	if (refin) crc = reflect(crc, order);

	if (!refin) while (len--) crc = (crc << 8) ^ crctab[ ((crc >> (order-8)) & 0xff) ^ *p++];
	else while (len--) crc = (crc >> 8) ^ crctab[ (crc & 0xff) ^ *p++];

	if (refout^refin) crc = reflect(crc, order);
	crc^= crcxor;
	crc&= crcmask;

	return(crc);
}

unsigned long SEASOB::CalcCRC32(char* string, int len)
{
// Calculate CRC32 for string passed in "string" 

	int i;
	unsigned long bit,crc;

// at first, compute constant bit masks for whole CRC and CRC high bit

	crcmask = ((((unsigned long)1<<(order-1))-1)<<1)|1;
	crchighbit = (unsigned long)1<<(order-1);

// generate lookup table

	generate_crc_table();

// compute missing initial CRC value

	if (!direct) {

		crcinit_nondirect = crcinit;
		crc = crcinit;
		for (i=0; i<order; i++) {

			bit = crc & crchighbit;
			crc<<= 1;
			if (bit) crc^= polynom;
		}
		crc&= crcmask;
		crcinit_direct = crc;
	}

	else {

		crcinit_direct = crcinit;
		crc = crcinit;
		for (i=0; i<order; i++) {

			bit = crc & 1;
			if (bit) crc^= polynom;
			crc >>= 1;
			if (bit) crc|= crchighbit;
		}	
		crcinit_nondirect = crc;
	}
	
// call CRC algorithm

//	crc = crctablefast((unsigned char *)string, strlen(string));	
	crc = crctablefast((unsigned char *)string, len);	
        return(crc);
}
int SEASOB::GetSEAS_OB_size()
{
	return No_SEASOBS_Elements;
}


