/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.c
 * Copyright (C) Paul Chinn 2014 <pchinn@as101.amverseas.noaa.gov>
 * 
*/

//#include <log4cpp/Category.hh>
//#include <log4cpp/FileAppender.hh>
//#include <log4cpp/PatternLayout.hh>
#define LOGFILE "./test.log"

#ifdef _WIN32
#include <windows.h>
#endif
#include <errno.h>

//#include <iostream>
//#include <string>
#include <FM94Elem.h>
#include <SEASOB_1.h>
#include <jjvv_1.h>
#include <jjvv_2.h>
#include <jjvv_3.h>
#include <time.h>
#include <iostream>
#include <fstream>
#ifdef _WIN32
#include <direct.h>
#endif


#ifndef _WIN32
#include <dirent.h>
#endif

using namespace std;
int DirListBin(string dir, bool RT, vector<string> *files);

//std::string format(const char *fmt, ...); 
//std::string format1(const char *format, int var );
//std::string format1(const char *format, float var);
//std::string format1(const char *format, char *var);
//std::string format1(const char *format, std::string var);

static RetMess data;


int DirListBin(string dir, bool RT, vector<string> *files)
{
	std::string SourcePath;
	SourcePath=dir;
	std::string Filename;
	
	cout << "Source Directory is "<< dir << "\n" <<flush;

#ifdef _WIN32
    static HANDLE searchHandle;
    static WIN32_FIND_DATA foundFile;
	if(RT)
	{
		Filename = SourcePath + "\\*.in";
	}
	else
	{
		Filename = SourcePath + "\\*.bin";
	}
	searchHandle = FindFirstFile(Filename.c_str(), &foundFile);
	if(searchHandle != INVALID_HANDLE_VALUE)
	{

		do {
			   if(!(foundFile.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			   {
				   std::string FilePath = SourcePath;
				   FilePath = SourcePath + "\\" + (foundFile.cFileName);
				   files->push_back(FilePath);

			   }
//			   else
		}while(FindNextFile(searchHandle, &foundFile));
		return files->size();
	}
	else
	{
		return 0;
	}


#endif

#ifndef _WIN32

    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) {
        cout << "Error(" << errno << ") opening " << dir << endl;
        return errno;
    }

    while ((dirp = readdir(dp)) != NULL)
	{
		string fname = dirp->d_name;
//		cout << fname.rfind(".bin") << endl;
		if(RT)
		{
			
//			cout << fname.rfind(".in") << endl;
			if(fname.rfind(".in")!=string::npos)
			{
				string FullName = dir+"/"+fname;   
	 //       	files->push_back(string(dirp->d_name));
				files->push_back(FullName);
			}
		}
 		else
		{
			if(fname.rfind(".bin")!=string::npos)
			{
				string FullName = dir+"/"+fname;   
	 //       	files->push_back(string(dirp->d_name));
				files->push_back(FullName);
			}
		}
   }
    closedir(dp);
    return files->size();
#endif

}


int main(int argc,char* argv[] )
{
	bool RT = false;

	string dir = string(".");

	for(int i=1;i< argc;i++)
	{
		if(strcmp(argv[i],"-r")==0)
		{
			RT = true;
		}
		else if (strcmp(argv[i],"-d")==0)
		{
			if((i+1) <= argc)
			{
				dir = argv[i+1];
				i++;
			}
		}
		else
		{
			printf("Usage: bin2nodc -r -d Directory \r\n       -r indicates real time binary files\r\n\r\n");
			exit(0);
		}
	}


    vector<string> files = vector<string>();

	int NumFiles = DirListBin(dir,RT, &files);
	cout << "Number of files is "<< NumFiles << endl;
	if(NumFiles==0)
	{
		return (-1);
	}


	

	JJVV xbt; // used to decode message type 1
//	JJVV_2 XBT2; // used to decode message type 2

	unsigned long CRC = -1;
//	int xyz = XBT2.GetDataType();
	

	ifstream infile;
	ofstream ofile;
	int i;

	for(i=0;i<(int)files.size();i++)
	{
		cout << files.at(i).c_str() << endl;
		std::string NODCFile="";
		infile.open(files.at(i).c_str(),ios::in|ios::binary|ios::ate); // open at end of file
		if(infile.is_open())
		{
			if(RT)
			{
				int length = infile.tellg();
				data.size = length-137;
				data.Mess = new char [length-137];
				infile.seekg(137);
				infile.read (data.Mess, length-137);
				infile.close();
			}
			else
			{
				int length = infile.tellg();
				data.size = length;
				data.Mess = new char [length];
				infile.seekg(0);
				infile.read (data.Mess, length);
				infile.close();
			}


		}
		char x = data.Mess[9]/ 4; //xFC; Skip over the call sign to look at SEAS 2k indicator (all ones)
		int MessType = (unsigned char)data.Mess[9]/4;
		if(MessType==63) // All ones therefore probably a SEAS 2k Message
		{
			int SeasType=0;
			SeasType = ((unsigned char)data.Mess[9]&(unsigned char) 0x03)*256
				+ (unsigned char) data.Mess[10];

/*			int BitPos=0;
			if(!xbt.DecodeElements(0,xbt.GetSEAS_OB_size(), &data, &BitPos))
			{
				continue; // could not decode
			}
			
*/


			unsigned long crc=-1;//26902; // NO GTS CRC
			std::string OFileName;
			OFileName=files.at(i).c_str();
			int BinPos;
			if(RT)
			{
				BinPos = OFileName.rfind(".in");
			}
			else
			{
				BinPos = OFileName.rfind(".bin");
			}

			OFileName.replace(BinPos,4,".ndc");
			if(SeasType==1)
			{
				JJVV profile;
				JJVV profile1;
				profile.DecodeBinMess(&data);
				profile1.DecodeBinMess(&data);
				profile1.CleanUpRawData();
				profile1.ComputeTailDepth();
				string build = profile1.BuildJJVVMess(1);

				if(!profile1.CalcJJVVCrc(&build,&crc))
				{
					crc=0xFFFFFFFF;
				}
				profile.ComputeInflectionPoints();
//				profile.SetProbeSerial(565432);
				
//				RetMess abc;

				bool success = false;
				unsigned long MyCRC1 = profile.GetUniqueTag();

				NODCFile=profile.NODCform(&crc);
#ifdef _WIN32
				int slash = OFileName.rfind("\\");
#endif
#ifndef _WIN32
				int slash = OFileName.rfind("/");
#endif
				OFileName.insert(slash+1,profile.GetWMO_ID()+"_");
				ofile.open(OFileName.c_str(),ios::out|ios::binary); // open at end of file
				if(ofile.is_open())
				{
					ofile.write(NODCFile.c_str(), NODCFile.size());
					ofile.close();
				}
			}
			else if(SeasType==2)
			{
				JJVV_2 profile;
				JJVV_2 profile1;
//				RetMess abc;

				profile.DecodeBinMess(&data);
				profile1.DecodeBinMess(&data);
				profile1.CleanUpRawData();
				profile1.ComputeTailDepth();
				string build = profile1.BuildJJVVMess(1);
				if(!profile1.CalcJJVVCrc(&build,&crc))
				{
					crc=0xFFFFFFFF;
				}
				profile.ComputeInflectionPoints();
				NODCFile=profile.NODCform(&crc);
#ifdef _WIN32
				int slash = OFileName.rfind("\\");
#endif
#ifndef _WIN32
				int slash = OFileName.rfind("/");
#endif
				OFileName.insert(slash+1,profile.GetWMO_ID()+"_");
				ofile.open(OFileName.c_str(),ios::out|ios::binary); // open at end of file
				if(ofile.is_open())
				{
					ofile.write(NODCFile.c_str(), NODCFile.size());
					ofile.close();
				}
			}
			else if(SeasType==3)
			{
				JJVV_3 profile;
				JJVV_3 profile1;
//				RetMess abc;

				profile.DecodeBinMess(&data);
				profile1.DecodeBinMess(&data);
				profile1.CleanUpRawData();
				profile1.ComputeTailDepth();
				string build = profile1.BuildJJVVMess(1);
				if(!profile1.CalcJJVVCrc(&build,&crc))
				{
					crc=0xFFFFFFFF;
				}
				profile.ComputeInflectionPoints();
				NODCFile=profile.NODCform(&crc);
#ifdef _WIN32
				int slash = OFileName.rfind("\\");
#endif
#ifndef _WIN32
				int slash = OFileName.rfind("/");
#endif
				OFileName.insert(slash+1,profile.GetWMO_ID()+"_");
				ofile.open(OFileName.c_str(),ios::out|ios::binary); // open at end of file
				if(ofile.is_open())
				{
					ofile.write(NODCFile.c_str(), NODCFile.size());
					ofile.close();
				}
			}
		}
		delete [] data.Mess;
	}
}
			

/*JJVV_2 GetJJVV()
{	JJVV_2 X; //= (JJVV_2) new JJVV_2();
	return X;
}
*/
