//#include <vector>

// PIC 11/05/2014  Moved BitPos to protected

#include <algorithm>
#include <SEASOB_1.h>
#include <time.h>
#ifndef JJVV_H
#pragma once
#define JJVV_H
#define MedPts 11
#define MAXINFPTS 30

#include <string>
#include <vector>
#include <stdio.h>
#include <stdarg.h>

#ifndef SEAS_ELEM_DEF
#define SEAS_ELEM_DEF
	typedef std::vector<FM94Elem *> SEASElem;
	typedef struct {int size; char* Mess;} RetMess;
#endif

struct DepTemp
{
	int Depth;
	float Temp;
};

struct FDepTemp
{
	float Depth;
	float Temp;
};

#ifndef _WIN32
	typedef char _int8;
#endif


//using namespace std;
typedef std::vector <FXY22042S> Temps;
typedef std::vector <DepTemp> InfPnt;
typedef std::vector <float> FloatVect;
typedef std::vector <double> DoubleVect;
typedef std::vector <std::string> StringVect;
//typedef CArray <float, float> FloatVect;
//CArray <float, FXY22042S> MySeaTemp;
//typedef struct {int size; char* Mess;} RetMess;


class JJVV : public SEASOB
{
private:
protected:
	
	int SetBitPos;
	int BitPos;
	char *BinaryMess;
//	int MessSize;
//	int JJVVGenSize;
	unsigned long CRC;
//	SEASElem JJVVPtrs;
	FXY1200 ShipName;
	FXY1201 Lloyds;
//	FXY48301 CruiseName;
	FXY48302 UniqueTag;
	FXY48201 SEASVersion;
	FXY48300 ProbeSerial;
	FXY48303 ThisDataIs;
	FXY33003 DataQual;
	FXY22067 InstType;
	FXY22068 RecorderType;
	FXY2002  TypeWindInst;
	FXY11001 WindDir;
	FXY11002 WindSpeed;
	FXY12004 DryBulbTemp;
	FXY2030  CurrMeasMeth;
	FXY22004 CurrentDir;
	FXY22031 CurrentSpeed;
	FXY22063 TotalWaterDepth;
	FXY100000 NoRepFields;
	FXY31200 TimesReplicated;
	FXY22042S SeaTemp;
	FXY7062S  SeaDepth;
//	CArray <FXY22042S, FXY22042S> MySeaTemp;
//	CArray <FXY22042S, FXY22042S> OneMeter;
//	CArray <double, double> RawSeaTemp;
	DoubleVect RawSeaTemp;
	Temps MySeaTemp;
	Temps OneMeter;
//	CArray <DepTemp, DepTemp> Inflection;
	InfPnt Inflection;
	bool EnoughToXmit();
	void SetTimesReplicated(int);
	float GetMedian(FloatVect *);
	std::string NODCformMETA_1 ( unsigned long *CRC);
	std::string NODCformProfile();
	FloatVect SmoothPts;
	bool TailsRem;
	bool OneMeterComputed;
	bool InflectComp;
	bool Smoothed;
	int TailDepth;
	bool CheckBit(int ,  char *);
	void SetBit(int , char , char * );
	bool ASCIIDecode;
//	CArray <CString, CString> Tokens;
	StringVect Tokens;

	int Proc8Group(int, char *, StringVect *);
	void Proc6Group(int,  StringVect *);


public :
	JJVV();
	JJVV(int);
	~JJVV();
//	void ComputeMessSize();
	void SetShipName(char *);
//	void SetCruiseName(char *);
	void SetProbeSerial(int);
	void SetSEASVersion(int);
	void SetDataQual(int);
	void SetInstType(int);
	void SetRecorderType(int);
	void SetDryBulbTemp(float);
	void SetTotalWaterDepth(int);
	void SetCurrentSpeed(float);
	void SetCurrentDir(int);
	void SetWindSpeed(float);
	void SetWindDir(int);
	void SetCurrMeasMeth(int);
	void SetLloyds(int);
	void SetUniqueTag(time_t, time_t);
	void SetUniqueTag(unsigned long);
	void SetDataType(int);
	void SetTypeWindInst(int);
//	void SetShipSpeed(float);
//	void SetShipDir(int);
	void AddNewTemp(float);

	std::string GetShipName();
	int GetProbeSerial();
	int GetSEASVersion();
	int GetDataQual();
	int GetInstType();
	Profiler GetInstInfo(int);
	CodeTable GetDataQualInfo(int);
	CodeTable GetRecorderInfo(int);
	CodeTable GetDataTypeInfo(int);
	CodeTable GetTypeWindInstInfo(int); 
	int GetRecorderType();
	float GetDryBulbTemp();
	int GetTotalWaterDepth();
	float GetCurrentSpeed();
	int GetCurrentDir();
	float GetWindSpeed();
	int GetWindDir();
	int GetCurrMeasMeth();
	CodeTable GetCurrMeasMethInfo(int);
	int GetLloyds();
	unsigned long GetUniqueTag();
	int GetDataType();
	int GetTypeWindInst();
	float GetTempAtPos(int);
	float GetTempAtDepth(int);
	float GetSmoothTempAtDepth(int);
	float GetDepthAtPos(int);
	int GetNoOfPoints();
	float GetOneMeterValueAt(int);
	int GetLastOMDepth();
	int ComputeLastDepth();
	int ComputeLastSmoothDepth();
	int ComputeTailDepth();
	bool CompOneMeterValues();
	bool ComputeInflectionPoints();
	int GetNumInflectPts();
	DepTemp GetInfPointAt(int);
	FDepTemp GetSmoothPointAt(int);
	int GetNumOfSmoothPoints();

	bool TailsRemoved();
	bool OneMeterComp();
	void OneMeterClear();
	void OneMeterAdd(float);
	int GetTailDepth();
	void SetTailDepth(int );
	RetMess  BuildBinMess(int);
	bool DecodeBinMess(RetMess *);
	bool DecodeSEASIVJJ(RetMess *, int, int, int);
	std::string BuildJJVVMess(int);
	void RemoveNumOfRTPoints();
	bool DecodeJJVV(std::string);
	void ApplyMedianFilter();
	unsigned long ComputeMessCRC(bool *);
//	unsigned long CalcCRC32(char *, int);
	void CleanUpRawData();
	float GetRawTempAt(int);
	bool RawTempAvailable;
	void SetInflectComp(bool value);
	std::string format(const char *fmt, ...);
	bool DecodeElements(int start, int No_To_Decode, RetMess *InMess, int *BitPos);
	bool DecodeElements(RetMess *InMess, int *BitPos, FM94Elem *y);
    std::string NODCform(unsigned long *CRC); // Pass the GTS CRC if Necessary
	bool CalcJJVVCrc(std::string *mess, unsigned long *thiscrc);

};

#endif
